//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : ARRAYVAR.CPP
//
// Description:
//		Implementation of class ArrayVariable.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "ArrayVar.h"


ArrayVariable::ArrayVariable(char *key,unsigned int size)
	: ListElement(key,VAR_ARRAY)
{
	unsigned int cnt;

	if ((Values=new VALUETYPE[size])==NULL)
		fatal("ARRAYVAR: out of memory !!");
	if ((InitialValues=new VALUETYPE[size])==NULL)
		fatal("ARRAYVAR: out of memory !!");
	ArraySize=size;
	for (cnt=0; cnt<ArraySize; cnt++)
		InitialValues[cnt]=0;
	SetInitialValue();
}

ArrayVariable::ArrayVariable(char *key,unsigned int size,VALUE_ARRAY_TYPE values)
	: ListElement(key,VAR_ARRAY)
{
	unsigned int cnt;

	if ((Values=new VALUETYPE[size])==NULL)
		fatal("ARRAYVAR: out of memory !!");
	if ((InitialValues=new VALUETYPE[size])==NULL)
		fatal("ARRAYVAR: out of memory !!");
	ArraySize=size;
	for (cnt=0; cnt<ArraySize; cnt++)
		InitialValues[cnt]=values[cnt];
	SetInitialValue();
}

ArrayVariable::~ArrayVariable(void)
{
	delete Values;
	delete InitialValues;
}

VALUETYPE ArrayVariable::GetValue(unsigned int index)
{
	if (index>=ArraySize)
	{
		char *msg=alloc_msgmem();

		sprintf(msg,"ARRAYVAR: index %u out of range reading array variable %s !",index,GetKey());
		error(msg);

		dealloc_msgmem(msg);
		return((VALUETYPE) 0);
	}
	return(Values[index]);
}

void ArrayVariable::SetValue(unsigned int index,VALUETYPE value)
{
	if (index>=ArraySize)
	{
		char *msg=alloc_msgmem();

		sprintf(msg,"ARRAYVAR: index %u out of range assigning array variable %s !",index,GetKey());
		error(msg);

		dealloc_msgmem(msg);
	}
	else
		Values[index]=value;
}

void ArrayVariable::SetInitialValue(void)
{
	unsigned int cnt;

	for (cnt=0; cnt<ArraySize; cnt++)
		Values[cnt]=InitialValues[cnt];
}
