//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : ARRAYVAR.H
//
// Description:
//		Definition of class ArrayVariable derived from ListElement.
//		It is specially designed to store variables with double values.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __ARRAYVARIABLE

#include "ListElem.h"

typedef VALUETYPE *VALUE_ARRAY_TYPE;

class ArrayVariable : public ListElement
{
	unsigned int ArraySize;
	VALUE_ARRAY_TYPE Values;
	VALUE_ARRAY_TYPE InitialValues;

public:
	// constructor
	ArrayVariable(char *key,unsigned int size);
	ArrayVariable(char *key,unsigned int size,VALUE_ARRAY_TYPE values);

	// destructor
	~ArrayVariable(void);

	// value operations
	VALUETYPE GetValue(unsigned int index);
	void SetValue(unsigned int index,VALUETYPE value);
	void SetInitialValue(void);
};

#define __ARRAYVARIABLE
#endif

