//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : DEFINES.H
//
// Description:
//		Global definititons
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////
// calculation and variable precision
//
#define VALUETYPE double

///////////////////////////////////////////////////
// numerical constant definitions
//
#define PI	3.14159265
#define PI2	PI*2

///////////////////////////////////////////////////
// Variables holding private variable identifiers.
// These variables are instantiated in MAIN.CPP
//
// 1. private variable function SINWT as T (implementation of sin(wt)==sin(2*pi*T*x)).
//    Occures in MAIN.CPP,CWAVFILE.CPP,FUNCTION.CPP,FKTPARS.Y
extern char V_SINWT_T;
// 2. private variable for the amplitude specified in model script
//    in statement GENERATE TONE.
//		Occures in MAIN.CPP,CWAVFILE.CPP
extern char V_AMPLITUDE;
// 3. private variable for function parameter,e.g f(parameter).
//		Occures in MAIN.CPP,FUNCTION.CPP
extern char V_PARAMETER;
// 4. private variable for relative sample-index.
//		Occures in MAIN.CPP,FUNCTION.CPP
extern char V_SAMPLEINDEX;

///////////////////////////////////////////////////
// Variables for flow control
//
// 1. stop on occurence of first warning
//    Occures in MAIN.CPP,OWNERR.CPP
extern char V_STOP_ON_WARNING;
// 2. stop on occurence of first error
//    Occures in MAIN.CPP,OWNERR.CPP
extern char V_STOP_ON_ERROR;
