//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : HASHTAB.H
//
// Description:
//		Definition of class HashTable.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __HASHTABLE

#include "SingList.h"

#define MAX_HASH 97		// should be prime number
class HashTable
{
	SinglyList HashArray[MAX_HASH];

public:
	// constructor
	HashTable(void);

	// destructor
	~HashTable(void);

	// table operations
	// insert new element
	void Insert(ListElement *newelement);
	// search element with specific key
	ListElement *Search(char *key,char type);

	// Remove complete external chains
	void CleanUp(void);

	// Reset all Elements to their predefined values
	void SetInitialValue(void);

private:
	unsigned int HashFunction(char const *key);
	void RemoveAll();
};

#define __HASHTABLE
#endif
