	TITLE	intel
	DOSSEG
	.model	small
	.stack	100h

;-----------------------------------------------------------------------------
; Include file section
;-----------------------------------------------------------------------------
	includelib	\masm\lib\miscutil.lib
	includelib	\masm\lib\videofns.lib


;-----------------------------------------------------------------------------
; External declarations
;-----------------------------------------------------------------------------
	public	OBJ_INTEL

	extrn	_CPUID_:	proc
	extrn	Set_cursor:	proc
	extrn	Get_cursor:	proc
	extrn	HEX32OUT:	proc
	extrn	CLS:		proc

;-----------------------------------------------------------------------------
; Local variables & Equates
;-----------------------------------------------------------------------------
        KBD_ReadFn      equ     0       ; function to read keyboard
	KBD_StatusFn	equ	1	; function to read keyboard status

	IO_Delay	MACRO
	out	0ebh,ax
	ENDM

;-----------------------------------------------------------------------------
; Misc data variables
;-----------------------------------------------------------------------------
	.data
	PSeriesMsg	label	byte
			db	"P6:     "
	P6Buffer	db	"         ",0dh,0ah
			db	"P5:     "
	P5Buffer	db	"         ",0dh,0ah
			db	"P4:     "
	P4Buffer	db	"         ",0dh,0ah
			db	"P3:     "
	P3Buffer	db	"         ",0dh,0ah
			db	"P2:     "
	P2Buffer	db	"         ",0dh,0ah
			db	"P2:     "
	P1Buffer	db	"         ",0dh,0ah
			db	"P0:     "
	P0Buffer	db	"         ",0dh,0ah,24h


	P6Count 	dd	0
	P5Count 	dd	0
	P4Count 	dd	0
	P3Count 	dd	0
	P2Count 	dd	0
	P1Count 	dd	0
	P0Count 	dd	0

	CPUTbl1 	dw	offset	P6Count
			dw	offset	P5Count
			dw	offset	P4Count
			dw	offset	P3Count
			dw	offset	P2Count
			dw	offset	P1Count
			dw	offset	P0Count

	CPUTbl2 	dw	offset	P6Buffer
			dw	offset	P5Buffer
			dw	offset	P4Buffer
			dw	offset	P3Buffer
			dw	offset	P2Buffer
			dw	offset	P1Buffer
			dw	offset	P0Buffer

	CPUID_Buffer	db	"        $"

	_cpu_type	dw	?

;-----------------------------------------------------------------------------
;
;-----------------------------------------------------------------------------
	.code
	.386
	OBJ_INTEL	label	word
    ifdef	RRC
	org	00452h
    endif

start:	mov	ax, @data
	mov	ds, ax		; set segment register
	mov	es, ax		; set segment register
	and	sp, not 3	; align stack to avoid AC fault
	call	CLS		; clear screen
	call	Get_cursor
	mov	ah,9
	mov	dx,offset PSeriesMsg		; get message buffer address
	int	21h
	mov	P6Buffer[8],'$' 	; make ASCII$ string
	mov	P5Buffer[8],'$' 	; make ASCII$ string
	mov	P4Buffer[8],'$' 	; make ASCII$ string
	mov	P3Buffer[8],'$' 	; make ASCII$ string
	mov	P2Buffer[8],'$' 	; make ASCII$ string
	mov	P1Buffer[8],'$' 	; make ASCII$ string
	mov	P0Buffer[8],'$' 	; make ASCII$ string
	mov	al,8fh
	out	70h,al
	in	al,71h

;-----------------------------------------------------------------------------
; Initialize timer tick
;-----------------------------------------------------------------------------
if 0
	cli				; disable interrupts
	mov	al,36h			; timer-0, mode 3
	out	43h,al
	IO_Delay
	mov	ax,0100h
	out	40h,al
	IO_Delay
	mov	ah,al
	out	40h,al
	sti
	hlt
endif

@GetCPUID:
	db 0f1h
	call	_CPUID_ 		; determine processor type
	mov	_cpu_type,ax		; save it
	db 0f1h
	call	print
	mov	_cpu_type,0		; clear it...for later
	mov	ah,KBD_StatusFn 	; get keyboard status
	int	16h			; read keyboard status
	jz	@GetCPUID

	cli				; disable interrupts
	mov	al,36h			; timer-0, mode 3
	out	43h,al
	IO_Delay
	mov	ax,0000h
	out	40h,al
	IO_Delay
	mov	ah,al
	out	40h,al
	sti

        mov     ah,KBD_ReadFn           ; read keyboard function
        int     16h                     ; get get key
	mov	ax, 4c00h	; terminate program
	int	21h


;-----------------------------------------------------------------------------
  print proc	near
;-----------------------------------------------------------------------------
	xor	bx,bx
	mov	bl,byte ptr _cpu_type[1]; get CPUID
	and	bl,0fh			; keep low nibble
	shl	bx,1			; *2
	mov	si,CPUTbl1[bx]		; get pointer to variable
	add	word ptr [si],1 	; adjust CPUID counter
	adc	word ptr [si][2],0
	mov	dx,608h 		; get initial row/col pointer
	mov	cl,byte ptr _cpu_type[1]; get CPUID
	and	cl,0fh			; keep low nibble
	sub	dh,cl
	call	Set_cursor		; set cursor position
	mov	si,CPUTbl1[bx]
	mov	di,CPUTbl2[bx]		; get buffer pointer
	call	HEX32OUT		; do buffer
	mov	ah,9			; print it
	mov	dx,CPUTbl2[bx]		; get buffer address
	int	21h
	mov	dx,612h 		; get initial row/col pointer
	mov	cl,byte ptr _cpu_type[1]; get CPUID
	and	cl,0fh			; keep low nibble
	sub	dh,cl
	call	Set_cursor		; set cursor position
	mov	si,offset _cpu_type
	mov	di,offset CPUID_Buffer	; get buffer pointer
	call	HEX32OUT		; do buffer
	mov	ah,9			; print it
	mov	dx,offset CPUID_Buffer	; get buffer address
	int	21h
	ret
print	endp
	end	start
