//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : LISTELEM.H
//
// Description:
//		Definition of virtual baseclass ListElement.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __LISTELEM

#include <string.h>
#include "defines.h"
#include "ownerr.h"

#define VAR_SIMPLE	0x01
#define VAR_ARRAY		0x02

class ListElement
{
	char *Key;
	char ElementType;

public:
	// constructor
	ListElement(char *key,char type)
										{ 	
											if ((Key=new char[strlen(key)+1])==NULL)
												fatal("SIMPLVAR: out of memory!!");
											strcpy(Key,key);
											ElementType=type;
										}

	// destructor
	~ListElement(void) 			{ delete Key; }

	// key operations
	char const *GetKey(void)	{ return(Key); }

	// type operations
	char const GetType(void)	{ return(ElementType); }

	virtual void SetInitialValue(void) { }
};

#define __LISTELEM
#endif

