//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : MATHFUNC.CPP
//
// Description:
//		Implemetation special mathematical functions
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////
#include <math.h>

#include "ownerr.h"

float gammln(float arg)
{
	float x,tmp,ser;

	static double cof[6]=
		{  76.18009173	,-86.50532033		, 24.01409822,
		   -1.231739516,  0.120858003E-2	 ,-0.536382E-5 };
	unsigned int j;

	x=arg-1.0;
	tmp=x+5.5;
	tmp-=(x+0.5)*log(tmp);
	ser=1.0;
	for (j=0;j<=5;j++)
	{
		x+=1.0;
		ser+=cof[j]/x;
	}
	return (-tmp+log(2.50662827456*ser));
}

float	factrl(float floatarg)
{
	static unsigned int ntop=4;
	static float a[33]=
		{ 1.0 , 1.0 , 2.0 , 6.0 , 24.0};
	unsigned int j;
	int arg=(int) floatarg;

	if ((float) arg!=floatarg)
		fatal("float factorial in function FACTRL\n");
	if (arg<0)
		fatal("Negative factorial in function FACTRL\n");
	if (arg>32)
		return(exp(gammln(arg+1.0)));
	while (ntop<arg)
	{
		j=ntop++;
		a[ntop]=a[j]*ntop;
	}
	return(a[arg]);
}
