//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : NODE.CPP
//
// Description:
//		Derivation tree node implementation
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#include <string.h>
#include "ownerr.h"
#include "Node.h"

// constructor
Node::Node(WORD o, VALUETYPE v)
{
	op = o;
	val_type=VALUE_NUMERIC;
	left.value = v;
	right = third = (Node *) 0;
}

Node::Node(WORD o, Node *l, Node *r, Node *last)
{
	op = o;
	val_type=VALUE_NUMERIC;
	left.np = l;
	right = r;
	third = last;
}

Node::Node(WORD o, char *string)
{
	op=o;
	val_type=VALUE_STRING;
	if ((left.strval=new char[strlen(string)+1])==NULL)
		fatal("out of memory!!");
	strcpy(left.strval,string);
	right = third = (Node *) 0;
}

// destructor
Node::~Node()
{
	if (val_type==VALUE_STRING)
		delete left.strval;
}

