//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : NODE.H
//
// Description:
//		Derivation tree node definition
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <ccpptyp.h>

#include "defines.h"

#ifndef __VAR_STRUCT
#define __VAR_STRUCT
typedef struct variable_struct
{
	VALUETYPE value;
	unsigned char used_as_parameter ;
};

#endif

#ifndef __FUNCTION_NODE

// val_type definitions
#define VALUE_NUMERIC 0x01
#define VALUE_STRING  0x02


class Node;

typedef union {
	VALUETYPE value;
	char *strval;
	Node	*np;
} ITEM;

struct Node {		// tree node
	WORD	op;		// operator
	char val_type; // value numeric or string (only important for destructor)
	ITEM	left;		// first operand
	Node	* right;	// second operand
	Node	* third;	// IF with ELSE part
	// constructor
	Node(WORD o, VALUETYPE v);
	Node(WORD o, Node *l, Node *r = 0, Node *last = 0);
	Node(WORD o, char *string);
	~Node();
};

#define __FUNCTION_NODE
#endif

#define LEFT	left.np
#define RIGHT	right

