;
;	________________________________________________________________
;
;	                          NWCall32.asm
;	                  32-Bit NetWare API DLL V1.00
;	        06-21-1996 Sven B. Schreiber sbs@psbs.franken.de
;	                 This is Public Domain Software
;	________________________________________________________________
;
;
;
;==============================================================================
;
; Assembly Instructions
; ---------------------
;
; Use MASM 6.11 to assemble this file.
; Recommended MASM command line: ml /I. /Zm /c /Cp /Ta NWCall32.asm
;
;==============================================================================
;
; Disclaimer
; ----------
;
; This software is provided "as is" and any express or implied warranties,
; including, but not limited to, the implied warranties of merchantibility and
; fitness for a particular purpose are disclaimed. In no event shall the
; author Sven B. Schreiber be liable for any direct, indirect, incidental,
; special, exemplary, or consequential damages (including, but not limited to,
; procurement of substitute goods or services; loss of use, data, or profits;
; or business interruption) however caused and on any theory of liability,
; whether in contract, strict liability, or tort (including negligence or
; otherwise) arising in any way out of the use of this software, even if
; advised of the possibility of such damage.
;
;==============================================================================
;
CONSOLE			equ	0		;0 = gui, 1 = console
UNICODE			equ	0		;0 = ansi, 1 = unicode
DLL			equ	1		;0 = application, 1 = dll
WIN95			equ	0		;0 = windows nt, 1 = windows 95
;
;==============================================================================
;
	include	W32Main.inc			;Win32 main header file
;
;==============================================================================
;
IMPORT			"NTK"			;import library list
;
;------------------------------------------------------------------------------
;
DEFAULT_ICON		equ	101		;application icon id
;
;==============================================================================
;
;	CONSTANTS
;
;==============================================================================
;
DAYS_1600_TO_1970		equ	((1970-1600)*365)+25+24+24+17
DAYS_PER_400_YEARS		equ	(400*365)+25+24+24+24
DAYS_PER_100_YEARS		equ	(100*365)+25
DAYS_PER_4_YEARS		equ	(004*365)+01
DAYS_PER_YEAR			equ	365
;
;==============================================================================
;
;	MAIN SEGMENT
;
;==============================================================================
;
BeginImage	_main, text, data
;
;==============================================================================
;==============================================================================
;====== .TEXT SECTION =========================================================
;==============================================================================
;==============================================================================
;
BeginCode
;
;------------------------------------------------------------------------------
;
	include	W32Start.inc			;Win32 startup code
;
;==============================================================================
;
;	DLL ENTRY POINT
;
;==============================================================================
;
;	>	[ebp+08]  -  hInstDLL
;		[ebp+12]  -  dReason
;		[ebp+16]  -  dParamDLL
;
;	<	     eax  -  return code
;
;------------------------------------------------------------------------------
;
LibMain:
	mov	eax,hInstDLL			;make hInstDLL global
	mov	hInst,eax
	mov	eax,TRUE			;initialization ok
	ret
;
;==============================================================================
;
;	DLL SERVICES
;
;==============================================================================
;
public	NWAttachToFileServer			;control functions
public	NWDetachFromFileServer
public	NWLoginToFileServer
public	NWLogoutFromFileServer
;
public	NWGetConnectionInformation		;service functions
public	NWGetConnectionNumber
public	NWGetFileServerDateAndTime
public	NWGetFileServerUTCTime
public	NWGetFileServerVersionInfo
public	NWGetInetAddr
public	NWGetLoginPasswordKey
public	NWGetObjectID
public	NWGetObjectName
public	NWGetVolumeName
;
public	NWCRequest				;auxiliary functions
public	NWCRequestSingle
public	NWLongSwap
public	NWWordSwap
;
public	NwlibGetLoginKey			;library functions
public	NwlibGetPasswordKey
public	NwlibEncryptPassword
public	NwlibEncrypt
public	NwlibLoginUserObject
public	NwlibLoginObject
public	NwlibLoginObjectEncrypted
public	NwlibUTCTimeToDateAndTime
public	NwlibGetCompletionCode
;
;==============================================================================
;
;	CONTROL FUNCTIONS
;
;==============================================================================
;
;	>	dArg01  -  server name
;		dArg02  -  reserved
;		dArg03  -  connection handle buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWAttachToFileServer:
	ApiPrologue
	mov	esi,dArg01			;create connection handle
	call	CreateConnectionHandle
	mov	ebx,dArg03			;save connection handle
	mov	[ebx],edi
	cmp	edi,NULL			;allocation error?
	mov	eax,STATUS_NO_MEMORY
	jz	NWAttachToFileServer1
	mov	esi,dArg01			;open server
	call	OpenServer
NWAttachToFileServer1:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 3
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWDetachFromFileServer:
	ApiPrologue
	mov	edi,dArg01			;close server
	call	CloseServer
	push	eax
	Win32	LocalFree,\			;deallocate handle structure
		dArg01
	pop	eax
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 1
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  object name
;		dArg03  -  object type
;		dArg04  -  object password
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWLoginToFileServer:
	ApiPrologue
	Win32	LocalAlloc,\			;allocate temporary buffer
		LMEM_FIXED+LMEM_ZEROINIT,\
		NWLOGIN_DATA_
	mov	edi,eax
	cmp	edi,NULL			;allocation error?
	mov	eax,STATUS_NO_MEMORY
	jz	NWLoginToFileServer3
	push	edi
	mov	esi,dArg04			;convert password to upper case
	lea	edi,[edi.ld_Password]
	mov	ecx,NW_MAX_PASSWORD_LEN
	call	CopyCStringToUpperCase
	pop	edi
	push	edi
	lea	edi,[edi.ld_Key]		;get login key from server
	Call32	NwlibGetLoginKey,\
		dArg01,\
		edi
	pop	edi
	jnb	NWLoginToFileServer1
	push	edi
	lea	esi,[edi.ld_Password]		;try clear login
	Call32	NwlibLoginObject,\
		dArg01,\
		dArg02,\
		dArg03,\
		esi
	pop	edi
	jmp	NWLoginToFileServer2
NWLoginToFileServer1:
	push	edi
	lea	edi,[edi.ld_ObjectId]		;get object id
	Call32	NWGetObjectID,\
		dArg01,\
		dArg02,\
		dArg03,\
		edi
	pop	edi
	mov	eax,edx
	jb	NWLoginToFileServer2
	push	edi
	lea	esi,[edi.ld_Password]		;get password length
	call	GetAnsiStringLength
	pop	edi
	push	edi
	mov	eax,[edi.ld_ObjectId]		;use object id as key
	xchg	al,ah
	rol	eax,16
	xchg	al,ah
	lea	esi,[edi.ld_Password]		;encrypt password
	lea	edi,[edi.ld_HashBuffer]
	Call32	NwlibEncryptPassword,\
		eax,\
		esi,\
		ecx,\
		edi
	pop	edi
	push	edi
	lea	esi,[edi.ld_HashBuffer]		;get password key
	lea	edi,[edi.ld_Key]
	Call32	NwlibGetPasswordKey,\
		edi,\
		esi,\
		edi
	pop	edi
	push	edi
	lea	esi,[edi.ld_Key]		;try encrypted login
	Call32	NwlibLoginObjectEncrypted,\
		dArg01,\
		dArg02,\
		dArg03,\
		esi
	pop	edi
NWLoginToFileServer2:
	push	eax
	Win32	LocalFree,\			;deallocate temporary buffer
		edi
	pop	eax
NWLoginToFileServer3:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWLogoutFromFileServer:
	ApiPrologue
	mov	ebx,NcpLogout			;create ncp packets
	call	CreateNcpPackets
	jb	NWLogoutFromFileServer1
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	call	DestroyNcpPackets		;destroy ncp packets
NWLogoutFromFileServer1:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 1
;
;==============================================================================
;
;	SERVICE FUNCTIONS
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  connection number
;		dArg03  -  object name buffer
;		dArg04  -  object type buffer
;		dArg05  -  object id buffer
;		dArg06  -  login time buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetConnectionInformation:
	ApiPrologue
	mov	ebx,NcpGetStationLoggedInformation ;create ncp packets
	call	CreateNcpPackets
	jb	NWGetConnectionInformation2
	lea	esi,dArg02			;copy connection number
	call	CopyWordToDword
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetConnectionInformation1
	mov	edi,dArg05			;copy object id
	call	CopySwapDword
	mov	edi,dArg04			;copy object type
	call	CopySwapWord
	mov	edi,dArg03			;copy object name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyDataBlock
	mov	edi,dArg06			;copy login time
	mov	ecx,NWDATE_TIME_
	call	CopyDataBlock
NWGetConnectionInformation1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetConnectionInformation2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 6
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  connection number buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetConnectionNumber:
	ApiPrologue
	mov	ebx,NcpGetStationNumber		;create ncp packets
	call	CreateNcpPackets
	jb	NWGetConnectionNumber2
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetConnectionNumber1
	add	esi,2				;skip ascii connection number
	mov	edi,dArg02			;copy connection number
	call	CopyByteToWord
NWGetConnectionNumber1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetConnectionNumber2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  date/time buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetFileServerDateAndTime:
	ApiPrologue
	mov	ebx,NcpGetFileServerDateAndTime	;create ncp packets
	call	CreateNcpPackets
	jb	NWGetFileServerDateAndTime2
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetFileServerDateAndTime1
	mov	edi,dArg02			;copy date/time
	mov	ecx,NWDATE_TIME_
	call	CopyDataBlock
NWGetFileServerDateAndTime1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetFileServerDateAndTime2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  date/time buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetFileServerUTCTime:
	ApiPrologue
	mov	ebx,NcpGetUtcTime		;create ncp packets
	call	CreateNcpPackets
	jb	NWGetFileServerUTCTime2
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetFileServerUTCTime1
	mov	edi,dArg02			;copy seconds since 01-01-1970
	call	CopyDword
NWGetFileServerUTCTime1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetFileServerUTCTime2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  version info buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetFileServerVersionInfo:
	ApiPrologue
	mov	ebx,NcpGetFileServerInformation	;create ncp packets
	call	CreateNcpPackets
	jb	NWGetFileServerVersionInfo2
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetFileServerVersionInfo1
	mov	ecx,vi_maximumServiceConnections ;swap all word members
	call	SwapWord
	mov	ecx,vi_connectionsInUse
	call	SwapWord
	mov	ecx,vi_maxNumberVolumes
	call	SwapWord
	mov	ecx,vi_maxConnectionsEverUsed
	call	SwapWord
	mov	edi,dArg02			;copy version info
	mov	ecx,VERSION_INFO_
	call	CopyDataBlock
NWGetFileServerVersionInfo1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetFileServerVersionInfo2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  connection number
;		dArg03  -  internet address buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetInetAddr:
	ApiPrologue
	mov	ebx,NcpGetInternetAddress	;create ncp packets
	call	CreateNcpPackets
	jb	NWGetInetAddr2
	lea	esi,dArg02			;copy connection number
	call	CopyWordToDword
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetInetAddr1
	mov	edi,dArg03			;copy internet address
	mov	ecx,NWINTERNET_ADDR_
	call	CopyDataBlock
	call	CopyByteToWord			;copy connection type
NWGetInetAddr1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetInetAddr2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 3
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  hashed password (16 bytes)
;		dArg03  -  key buffer (8 bytes)
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetLoginPasswordKey:
	ApiPrologue
	Call32	NwlibGetLoginKey,\		;get login key from server
		dArg01,\
		dArg03
	jb	NWGetLoginPasswordKey1		;error
	push	eax
	Call32	NwlibGetPasswordKey,\		;generate password key
		dArg03,\
		dArg02,\
		dArg03
	pop	eax
NWGetLoginPasswordKey1:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 3
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  object name
;		dArg03  -  object type
;		dArg04  -  object id buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetObjectID:
	ApiPrologue
	mov	ebx,NcpGetBinderyObjectId	;create ncp packets
	call	CreateNcpPackets
	jb	NWGetObjectID2
	lea	esi,dArg03			;copy object type
	call	CopySwapWord
	mov	esi,dArg02			;copy object name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyCStringToPascalString
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetObjectID1
	mov	edi,dArg04			;copy object id
	call	CopySwapDword
NWGetObjectID1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetObjectID2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  object id
;		dArg03  -  object name buffer
;		dArg04  -  object type buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetObjectName:
	ApiPrologue
	mov	ebx,NcpGetBinderyObjectName	;create ncp packets
	call	CreateNcpPackets
	jb	NWGetObjectName2
	lea	esi,dArg02			;copy object id
	call	CopySwapDword
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetObjectName1
	add	esi,4				;skip object id
	mov	edi,dArg04			;copy object type
	call	CopySwapWord
	mov	edi,dArg03			;copy object name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyDataBlock
NWGetObjectName1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetObjectName2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  volume number
;		dArg03  -  volume name buffer
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWGetVolumeName:
	ApiPrologue
	mov	ebx,NcpGetVolumeName		;create ncp packets
	call	CreateNcpPackets
	jb	NWGetVolumeName2
	lea	esi,dArg02			;copy volume number
	call	CopyByte
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWGetVolumeName1
	mov	edi,dArg03			;copy volume name
	mov	ecx,NW_MAX_VOLUME_NAME_LEN
	call	CopyPascalStringToCString
NWGetVolumeName1:
	call	DestroyNcpPackets		;destroy ncp packets
NWGetVolumeName2:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 3
;
;==============================================================================
;
;	AUXILIARY FUNCTIONS
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  ncp function number
;		dArg03  -  number of request fragments
;		dArg04  -  request fragment list
;		dArg05  -  number of reply fragments
;		dArg06  -  reply fragment list
;		dArg07  -  (reserved)
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWCRequest:
	ApiPrologue
	Win32	LocalAlloc,\			;allocate request record
		LMEM_FIXED+LMEM_ZEROINIT,\
		REQUEST_RECORD_
	mov	ebx,eax
	cmp	ebx,NULL			;allocation error?
	mov	eax,STATUS_NO_MEMORY
	jz	NWCRequest10
	movzx	eax,byte ptr dArg02		;set request code
	shl	eax,16
	mov	ax,-1
	mov	[ebx.rr_RequestCode],eax
	mov	eax,0				;init request buffer byte count
	mov	ecx,dArg03			;scan request fragment list
	mov	esi,dArg04
	jecxz	NWCRequest2			;no request fragments
NWCRequest1:
	add	eax,[esi+4]			;accumulate fragment sizes
	add	esi,4+4				;next request fragment
	loop	NWCRequest1
NWCRequest2:
	mov	[ebx.rr_RequestBufferSize],eax	;set request buffer size
	mov	eax,0				;init reply buffer byte count
	mov	ecx,dArg05			;scan reply fragment list
	mov	edi,dArg06
	jecxz	NWCRequest4			;no reply fragments
NWCRequest3:
	add	eax,[edi+4]			;accumulate fragment sizes
	add	edi,4+4				;next reply fragment
	loop	NWCRequest3
NWCRequest4:
	mov	[ebx.rr_ReplyBufferSize],eax	;set reply buffer size
	call	CreateNcpPackets		;create ncp packets
	jb	NWCRequest9
	mov	ecx,dArg03			;scan request fragment list
	mov	esi,dArg04
	jecxz	NWCRequest6			;no request fragments
NWCRequest5:
	push	ecx
	push	esi
	mov	ecx,[esi+4]			;copy request fragment
	mov	esi,[esi]
	call	CopyDataBlock
	pop	esi
	pop	ecx
	add	esi,4+4				;next request fragment
	loop	NWCRequest5
NWCRequest6:
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NWCRequest8
	mov	ecx,dArg05			;scan reply fragment list
	mov	edi,dArg06
	jecxz	NWCRequest8			;no reply fragments
NWCRequest7:
	push	ecx
	push	edi
	mov	ecx,[edi+4]			;copy reply fragment
	mov	edi,[edi]
	call	CopyDataBlock
	pop	edi
	pop	ecx
	add	edi,4+4				;next reply fragment
	loop	NWCRequest7
NWCRequest8:
	call	DestroyNcpPackets		;destroy ncp packets
NWCRequest9:
	push	eax
	Win32	LocalFree,\			;deallocate request record
		ebx
	pop	eax
NWCRequest10:
	call	GetCompletionCode		;get netware completion code
	ApiEpilogue 7
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  ncp function number
;		dArg03  -  request packet
;		dArg04  -  request packet size
;		dArg05  -  reply packet
;		dArg06  -  reply packet size
;		dArg07  -  (reserved)
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NWCRequestSingle:
	ApiPrologue
	push	dArg04				;prepare request fragment list
	push	dArg03
	lea	esi,[esp]
	push	dArg06				;prepare reply fragment list
	push	dArg05
	lea	edi,[esp]
	Call32	NWCRequest,\			;send ncp request
		dArg01,\
		dArg02,\
		1,\
		esi,\
		1,\
		edi,\
		dArg07
	lea	esp,[esp+4+4+4+4]		;remove fragment lists
	ApiEpilogue 7
;
;==============================================================================
;
;	>	dArg01  -  long word to swap
;
;	<	   eax  -  swapped long word
;
;------------------------------------------------------------------------------
;
NWLongSwap:
	ApiPrologue
	mov	eax,dArg01			;swap long word
	xchg	al,ah
	rol	eax,16
	xchg	al,ah
	ApiEpilogue 1
;
;==============================================================================
;
;	>	dArg01  -  word to swap
;
;	<	    ax  -  swapped word
;
;------------------------------------------------------------------------------
;
NWWordSwap:
	ApiPrologue
	mov	ax,word ptr dArg01		;swap word
	xchg	al,ah
	ApiEpilogue 1
;
;==============================================================================
;
;	LIBRARY FUNCTIONS
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  key buffer (8 bytes)
;
;	<	   eax  -  status code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NwlibGetLoginKey:
	ApiPrologue
	mov	ebx,NcpGetEncryptionKey		;create ncp packets
	call	CreateNcpPackets
	jb	NwlibGetLoginKey2
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	jb	NwlibGetLoginKey1
	mov	edi,dArg02			;copy login key
	mov	ecx,NWLOGIN_KEY_
	call	CopyDataBlock
NwlibGetLoginKey1:
	call	DestroyNcpPackets		;destroy ncp packets
NwlibGetLoginKey2:
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  input key buffer (8 bytes)
;		dArg02  -  hashed password (16 bytes)
;		dArg03  -  output key buffer (8 bytes)
;
;------------------------------------------------------------------------------
;
NwlibGetPasswordKey:
	ApiPrologue
	mov	ecx,32/4			;clear temporary output buffer
NwlibGetPasswordKey1:
	push	0
	loop	NwlibGetPasswordKey1
	mov	esi,dArg01			;apply 1st login key fragment
	lea	edi,[esp]
	Call32	NwlibEncryptPassword,\
		[esi],\
		dArg02,\
		16,\
		edi
	mov	esi,dArg01			;apply 2nd login key fragment
	lea	edi,[esp+16]
	Call32	NwlibEncryptPassword,\
		[esi+4],\
		dArg02,\
		16,\
		edi
	lea	esi,[esp]			;hash 32 bytes to 16 bytes
	lea	edi,[esp+32]
NwlibGetPasswordKey2:
	dec	edi
	mov	al,[edi]
	xor	[esi],al
	inc	esi
	cmp	esi,edi
	jnz	NwlibGetPasswordKey2
	lea	esi,[esp]			;hash 16 bytes to 8 bytes
	lea	edi,[esp+16]
	mov	ebx,dArg03
NwlibGetPasswordKey3:
	dec	edi
	mov	al,[edi]
	xor	al,[esi]
	inc	esi
	mov	[ebx],al
	inc	ebx
	cmp	esi,edi
	jnz	NwlibGetPasswordKey3
	add	esp,32				;remove temporary output buffer
	ApiEpilogue 3
;
;==============================================================================
;
;	>	dArg01  -  key
;		dArg02  -  password
;		dArg03  -  password length
;		dArg04  -  output buffer (16 bytes)
;
;------------------------------------------------------------------------------
;
NwlibEncryptPassword:
	ApiPrologue
	mov	ecx,32/4			;clear hash buffer
NwlibEncryptPassword1:
	push	0
	loop	NwlibEncryptPassword1
	mov	ebx,dArg02			;load password
	mov	ecx,dArg03			;load password length
	jecxz	NwlibEncryptPassword3		;zero length
NwlibEncryptPassword2:
	cmp	byte ptr [ebx+ecx-1],0		;ignore trailing zeroes
	jnz	NwlibEncryptPassword3
	loop	NwlibEncryptPassword2
NwlibEncryptPassword3:
	mov	ah,0				;clear end flag
	mov	esi,0				;init password index
NwlibEncryptPassword4:
	cmp	esi,ecx				;end of password?
	jz	NwlibEncryptPassword8
	mov	edx,esi				;save current password index
	mov	edi,0				;init hash buffer index
NwlibEncryptPassword5:
	cmp	esi,ecx				;end of password?
	jnz	NwlibEncryptPassword6
	mov	ah,1				;set end flag
	mov	esi,edx				;reuse last password fragment
	mov	al,byte ptr [EncryptionTable1+edi] ;load dummy byte
	jmp	NwlibEncryptPassword7
NwlibEncryptPassword6:
	mov	al,[ebx+esi]			;load password character
	inc	esi
NwlibEncryptPassword7:
	xor	[esp+edi],al			;hash password characters
	inc	edi
	cmp	edi,32				;end of hash buffer?
	jnz	NwlibEncryptPassword5
	cmp	ah,0				;end of password?
	jz	NwlibEncryptPassword4
NwlibEncryptPassword8:
	mov	eax,dArg01			;load key
	mov	edi,0				;init hash buffer index
NwlibEncryptPassword9:
	xor	[esp+edi],al			;hash password and key
	ror	eax,8
	inc	edi
	cmp	edi,32				;end of hash buffer?
	jnz	NwlibEncryptPassword9
	lea	esi,[esp]			;encrypt password
	Call32	NwlibEncrypt,\
		esi,\
		dArg04
	add	esp,32				;remove hash buffer
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  input buffer (32 bytes)
;		dArg02  -  output buffer (16 bytes)
;
;------------------------------------------------------------------------------
;
NwlibEncrypt:
	ApiPrologue
	mov	ebx,dArg01			;load input buffer
	mov	ch,0				;clear accumulator
	mov	cl,2				;load number of rounds
NwlibEncrypt1:
	mov	esi,0				;init input buffer index
NwlibEncrypt2:
	mov	al,[ebx+esi]			;hash input bytes
	add	al,ch
	movzx	edi,ch
	add	edi,esi
	and	edi,32-1
	mov	ah,[ebx+edi]
	sub	ah,byte ptr [EncryptionTable1+esi]
	xor	al,ah
	add	ch,al				;accumulate bytes
	mov	[ebx+esi],al			;store byte
	inc	esi
	cmp	esi,32				;end of input buffer?
	jnz	NwlibEncrypt2
	dec	cl				;next round
	jnz	NwlibEncrypt1
	mov	edx,dArg02			;load output buffer
	mov	esi,0				;init input buffer index
NwlibEncrypt3:
	movzx	edi,byte ptr [ebx+esi]		;get lower code nibble
	mov	al,byte ptr [EncryptionTable2+edi]
	inc	esi
	movzx	edi,byte ptr [ebx+esi]		;get higher code nibble
	mov	ah,byte ptr [EncryptionTable2+edi]
	inc	esi
	rol	ah,4				;add code nibbles
	or	al,ah
	mov	[edx],al			;store code byte
	inc	edx
	cmp	esi,32				;end of input buffer?
	jnz	NwlibEncrypt3
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  user name
;		dArg03  -  user password
;
;	<	   eax  -  status code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NwlibLoginUserObject:
	ApiPrologue
	mov	ebx,NcpLoginUserObject		;create ncp packets
	call	CreateNcpPackets
	jb	NwlibLoginUserObject1
	mov	esi,dArg02			;copy user name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyCStringToPascalString
	mov	esi,dArg03			;copy user password
	mov	ecx,NW_MAX_PASSWORD_LEN
	call	CopyCStringToPascalString
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	call	DestroyNcpPackets		;destroy ncp packets
NwlibLoginUserObject1:
	ApiEpilogue 3
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  object name
;		dArg03  -  object type
;		dArg04  -  object password
;
;	<	   eax  -  status code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NwlibLoginObject:
	ApiPrologue
	mov	ebx,NcpLoginObject		;create ncp packets
	call	CreateNcpPackets
	jb	NwlibLoginObject1
	lea	esi,dArg03			;copy object type
	call	CopySwapWord
	mov	esi,dArg02			;copy object name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyCStringToPascalString
	mov	esi,dArg04			;copy object password
	mov	ecx,NW_MAX_PASSWORD_LEN
	call	CopyCStringToPascalString
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	call	DestroyNcpPackets		;destroy ncp packets
NwlibLoginObject1:
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  connection handle
;		dArg02  -  object name
;		dArg03  -  object type
;		dArg04  -  object password key
;
;	<	   eax  -  status code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NwlibLoginObjectEncrypted:
	ApiPrologue
	mov	ebx,NcpLoginObjectEncrypted	;create ncp packets
	call	CreateNcpPackets
	jb	NwlibLoginObjectEncrypted1
	mov	esi,dArg04			;copy key
	mov	ecx,NWLOGIN_KEY_
	call	CopyDataBlock
	lea	esi,dArg03			;copy object type
	call	CopySwapWord
	mov	esi,dArg02			;copy object name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	CopyCStringToPascalString
	mov	ecx,dArg01			;send ncp request
	call	SendNcpRequest
	call	DestroyNcpPackets		;destroy ncp packets
NwlibLoginObjectEncrypted1:
	ApiEpilogue 4
;
;==============================================================================
;
;	>	dArg01  -  utc time
;		dArg02  -  date/time buffer
;
;------------------------------------------------------------------------------
;
NwlibUTCTimeToDateAndTime:
	ApiPrologue
	mov	edi,dArg02			;load date/time buffer
	mov	eax,dArg01			;load utc time
	mov	edx,0				;get second
	mov	ecx,60
	div	ecx
	mov	[edi.dt_Second],dl
	mov	edx,0				;get minute
	mov	ecx,60
	div	ecx
	mov	[edi.dt_Minute],dl
	mov	edx,0				;get hour
	mov	ecx,24
	div	ecx
	mov	[edi.dt_Hour],dl
	add	eax,DAYS_1600_TO_1970		;normalize day count
	mov	edx,0				;get 400-year block
	mov	ecx,DAYS_PER_400_YEARS
	div	ecx
	mov	esi,eax
	mov	bh,0				;init 100-year block count
	sub	edx,DAYS_PER_100_YEARS		;1st quarter?
	jb	NwlibUTCTimeToDateAndTime1
	inc	edx				;insert extra day
	inc	bh
	sub	edx,DAYS_PER_100_YEARS		;2nd quarter?
	jb	NwlibUTCTimeToDateAndTime1
	inc	edx				;insert extra day
	inc	bh
	sub	edx,DAYS_PER_100_YEARS		;3rd quarter?
	jb	NwlibUTCTimeToDateAndTime1
	inc	edx				;insert extra day
	inc	bh
	sub	edx,DAYS_PER_100_YEARS		;4th quarter
NwlibUTCTimeToDateAndTime1:
	add	edx,DAYS_PER_100_YEARS		;get day in 100-year block
	mov	eax,edx				;get 4-year block
	mov	edx,0
	mov	ecx,DAYS_PER_4_YEARS
	div	ecx
	mov	bl,al
	cmp	edx,0				;1st day in 4-year block?
	mov	eax,edx
	mov	edx,0
	jz	NwlibUTCTimeToDateAndTime2
	dec	eax				;remove leap day
	mov	ecx,DAYS_PER_YEAR		;get year block
	div	ecx
	cmp	eax,1				;insert leap day
	adc	edx,0
NwlibUTCTimeToDateAndTime2:
	mov	ch,al
	mov	ah,0				;reset leap year flag
	cmp	ch,0				;1st in 4-year group?
	jnz	NwlibUTCTimeToDateAndTime3
	mov	ah,1				;set leap year flag
	cmp	bl,0				;1st in 100-year group?
	jnz	NwlibUTCTimeToDateAndTime3
	cmp	bh,0				;1st in 400-year group?
	jz	NwlibUTCTimeToDateAndTime3
	mov	ah,0				;reset leap year flag
	dec	edx				;remove extra day
NwlibUTCTimeToDateAndTime3:
	push	esi
	mov	esi,dDaysPerMonth		;load month table
	mov	cl,0				;init month count
NwlibUTCTimeToDateAndTime4:
	inc	cl				;count months
	mov	al,[esi]			;load days per month
	inc	esi
	cmp	cl,2				;february?
	jnz	NwlibUTCTimeToDateAndTime5
	add	al,ah				;add 1 day if leap year
NwlibUTCTimeToDateAndTime5:
	sub	dl,al				;subtract number of days
	jnb	NwlibUTCTimeToDateAndTime6
	sub	edx,00000100h			;handle carry
NwlibUTCTimeToDateAndTime6:
	jb	NwlibUTCTimeToDateAndTime7	;month found
	cmp	cl,12				;last month?
	jnz	NwlibUTCTimeToDateAndTime4
NwlibUTCTimeToDateAndTime7:
	pop	esi
	add	dl,al				;get day in month
	inc	dl
	mov	[edi.dt_Day],dl			;set day
	mov	[edi.dt_Month],cl		;set month
	mov	eax,1600			;load base year
	movzx	ecx,ch				;add year in 4-year group
	add	eax,ecx
	movzx	ecx,bl				;add 4-year group
	shl	ecx,2
	add	eax,ecx
	movzx	ecx,bh				;add 100-year group
	mov	ebx,ecx
	shl	ecx,2
	add	ecx,ebx
	mov	ebx,ecx
	shl	ecx,2
	add	ecx,ebx
	shl	ecx,2
	add	eax,ecx
	mov	ecx,esi				;add 400-year group
	shl	ecx,2
	add	ecx,esi
	mov	esi,ecx
	shl	ecx,2
	add	ecx,esi
	shl	ecx,4
	add	eax,ecx
	sub	eax,1900			;set year
	mov	[edi.dt_Year],al
	ApiEpilogue 2
;
;==============================================================================
;
;	>	dArg01  -  status code
;
;	<	   eax  -  completion code
;		     c  -  set if error
;
;------------------------------------------------------------------------------
;
NwlibGetCompletionCode:
	ApiPrologue
	mov	eax,dArg01			;get netware completion code
	call	GetCompletionCode
	ApiEpilogue 1
;
;==============================================================================
;
;	DEVICE COMMUNICATIONS
;
;==============================================================================
;
;	>	esi  -  server name (ansi)
;		edi  -  connection handle
;
;	<	eax  -  status code
;
;------------------------------------------------------------------------------
;
OpenServer:
	lea	edx,[edi.ch_Handle]		;load device handle pointer
	mov	ebx,offset sDeviceNwrdr		;load redirector device name
OpenServer1:
	inc	ebx				;seek end of string
	cmp	byte ptr [ebx-1],0
	jnz	OpenServer1
	sub	ebx,offset sDeviceNwrdr		;compute length
	mov	ecx,esi				;load server name
OpenServer2:
	inc	ecx				;seek end of string
	cmp	byte ptr [ecx-1],0
	jnz	OpenServer2
	sub	ecx,esi				;compute buffer length
	add	ecx,ebx
	shl	ecx,1
	push	esi
	push	edx
	push	ecx
	call	CreateString			;create string structure
	pop	ecx
	pop	edx
	pop	esi
	cmp	edi,NULL			;error?
	mov	eax,STATUS_NO_MEMORY
	jz	OpenServer7
	dec	ecx				;set string length
	dec	ecx
	mov	[edi.ss_Length],cx
	mov	ah,0				;clear hi byte of unicode char
	mov	ecx,esi				;save server name
	mov	esi,offset sDeviceNwrdr		;load redirector device name
OpenServer3:
	mov	al,[esi]			;copy string
	inc	esi
	mov	[ebx],ax
	inc	ebx
	inc	ebx
	cmp	al,0
	jnz	OpenServer3
	mov	al,"\"				;insert separator
	mov	[ebx-2],ax
	mov	esi,ecx				;load server name
OpenServer4:
	mov	al,[esi]			;append string
	inc	esi
	mov	[ebx],ax
	inc	ebx
	inc	ebx
	cmp	al,0
	jnz	OpenServer4
	push	edx
	push	edi
	mov	ecx,0				;create control blocks
	call	CreateControlBlocks
	mov	ecx,edx
	mov	ebx,edi
	pop	edi
	pop	edx
	mov	[esi.oa_Length],OBJECT_ATTRIBUTES_ ;set object attributes
	mov	[esi.oa_RootDirectory],NULL
	mov	[esi.oa_ObjectName],edi
	mov	[esi.oa_Attributes],OBJ_CASE_INSENSITIVE
	mov	[esi.oa_SecurityDescriptor],NULL
	mov	[esi.oa_SecurityQualityOfService],NULL
	push	edx
	push	edi
	push	ecx
	push	ebx
	Win32	NtOpenFile,\			;open device
		edx,\
		FILE_READ_DATA+SYNCHRONIZE,\
		esi,\
		ebx,\
		FILE_SHARE_ALL,\
		FILE_SYNCHRONOUS_IO_NONALERT
	pop	ebx
	pop	ecx
	pop	edi
	pop	edx
	test	eax,eax				;warning or error?
	js	OpenServer5
	mov	eax,[ebx.io_Status]		;load i/o status code
	test	eax,eax				;warning or error?
	jns	OpenServer6
OpenServer5:
	mov	[edx],NULL			;clear device handle
OpenServer6:
	push	eax
	push	edi
	Win32	LocalFree,\			;deallocate control blocks
		ecx
	pop	edi
	Win32	LocalFree,\			;deallocate string structure
		edi
	pop	eax
OpenServer7:
	ret
;
;==============================================================================
;
;	>	edi  -  connection handle
;
;	<	eax  -  status code
;
;------------------------------------------------------------------------------
;
CloseServer:
	Win32	NtClose,\			;close device
		[edi.ch_Handle]
	ret
;
;==============================================================================
;
;	>	ebx  -  request record
;
;	<	ebx  -  request record
;		edi  -  input buffer
;		eax  -  status code
;		  c  -  set if error
;
;------------------------------------------------------------------------------
;
CreateNcpPackets:
	mov	ecx,4				;get input buffer size
	cmp	word ptr [ebx.rr_RequestCode],-1
	adc	ecx,[ebx.rr_RequestBufferSize]
	add	ecx,2
	mov	edx,4				;get output buffer size
	add	edx,[ebx.rr_ReplyBufferSize]
	add	edx,2
	mov	eax,ecx
	add	eax,edx				;compute temporary buffer size
	add	eax,IO_STATUS_BLOCK_
	push	ebx
	push	ecx
	push	edx
	Win32	LocalAlloc,\			;allocate temporary buffer
		LMEM_FIXED+LMEM_ZEROINIT,\
		eax
	mov	edi,eax
	pop	edx
	pop	ecx
	pop	ebx
	mov	[ebx.rr_MemoryHandle],edi	;save memory handle
	cmp	edi,NULL			;allocation error?
	mov	eax,STATUS_NO_MEMORY
	stc
	jz	CreateNcpPackets1
	lea	edi,[edi+4]			;set input buffer size
	sub	ecx,4+2
	mov	[edi-4],ecx
	mov	[ebx.rr_InBufferAddress],edi	;set input buffer address
	lea	edi,[edi+ecx+2+4]		;set output buffer size
	sub	edx,4+2
	mov	[edi-4],edx
	mov	[ebx.rr_OutBufferAddress],edi	;set output buffer address
	mov	edi,[ebx.rr_InBufferAddress]	;load input buffer address
	cmp	word ptr [ebx.rr_RequestCode],-1 ;skip subfunction byte if any
	adc	edi,0
	mov	eax,STATUS_SUCCESS		;ok
	clc
CreateNcpPackets1:
	ret
;
;==============================================================================
;
;	>	ebx  -  request record
;		edi  -  end of input buffer
;		ecx  -  connection handle
;
;	<	ebx  -  request record
;		esi  -  output buffer
;		eax  -  status code
;		  c  -  set if error
;
;------------------------------------------------------------------------------
;
SendNcpRequest:
	push	ebx
	mov	eax,[ebx.rr_RequestCode]	;load request code
	mov	esi,[ebx.rr_InBufferAddress]	;load input buffer address
	sub	edi,esi				;update input buffer size
	mov	[esi-4],edi
	mov	edi,[ebx.rr_OutBufferAddress]	;load output buffer address
	mov	ebx,[edi-4]			;get i/o status block address
	lea	ebx,[edi+ebx+2]
	cmp	ax,-1				;subfunction code included?
	jnb	SendNcpRequest1
	mov	[esi],al			;set subfunction code
SendNcpRequest1:
	shr	eax,16				;make device control code
	shl	eax,2
	or	eax,DEVICE_NWRDR_NCP
	push	edi
	push	ebx
	Win32	NtFsControlFile,\		;send request
		[ecx.ch_Handle],\
		NULL,\
		NULL,\
		NULL,\
		ebx,\
		eax,\
		esi,\
		[esi-4],\
		edi,\
		[edi-4]
	pop	ebx
	pop	edi
	mov	esi,edi				;load output buffer address
	cmp	eax,STATUS_SUCCESS		;error?
	jnz	SendNcpRequest2
	mov	eax,[ebx.io_Status]		;load i/o status code
SendNcpRequest2:
	cmp	eax,STATUS_SUCCESS		;error?
	stc
	jnz	SendNcpRequest3
	mov	ecx,[ebx.io_Information]	;update output buffer size
	mov	[esi-4],ecx
	clc					;ok
SendNcpRequest3:
	pop	ebx
	ret
;
;==============================================================================
;
;	>	ebx  -  request record
;		esi  -  end of output buffer
;		eax  -  status code
;
;	<	ebx  -  request record
;		eax  -  status code
;		  c  -  set if error
;
;------------------------------------------------------------------------------
;
DestroyNcpPackets:
	cmp	eax,STATUS_SUCCESS		;previous error?
	jnz	DestroyNcpPackets1
	mov	edi,[ebx.rr_OutBufferAddress]	;get number of bytes processed
	sub	esi,edi
	cmp	[edi-4],esi			;missing data?
	jnb	DestroyNcpPackets1
	mov	eax,STATUS_DATA_ERROR
DestroyNcpPackets1:
	mov	edi,NULL			;load/clear memory handle
	xchg	edi,[ebx.rr_MemoryHandle]
	push	eax
	push	ebx
	Win32	LocalFree,\			;deallocate temporary buffer
		edi
	pop	ebx
	pop	eax
	cmp	eax,STATUS_SUCCESS		;error?
	stc
	jnz	DestroyNcpPackets2
	clc					;ok
DestroyNcpPackets2:
	ret
;
;==============================================================================
;
;	>	eax  -  status code
;
;	<	eax  -  completion code
;		edx  -  status code
;		  c  -  set if error
;
;------------------------------------------------------------------------------
;
GetCompletionCode:
	push	eax
	Win32	SetLastError,\			;set system error code
		eax
	pop	eax
	mov	ebx,NWCCodeTable		;load conversion table address
GetCompletionCode1:
	mov	edx,[ebx]			;load sample status code
	cmp	edx,STATUS_UNDEFINED		;end of table?
	jz	GetCompletionCode2
	cmp	edx,eax				;status code found?
	jz	GetCompletionCode2
	add	ebx,4+4				;next table netry
	jmp	GetCompletionCode1
GetCompletionCode2:
	cmp	eax,STATUS_SUCCESS		;error?
	stc
	jnz	GetCompletionCode3
	clc					;ok
GetCompletionCode3:
	mov	edx,eax				;load device status code
	mov	eax,[ebx+4]			;load netware completion code
	ret
;
;==============================================================================
;
;	DATA COPYING FUNCTIONS
;
;==============================================================================
;
;	>	esi  -  source
;		edi  -  destination
;
;	<	esi  -  next source
;		edi  -  next destination
;
;	eax, ebx, ecx not affected
;
;------------------------------------------------------------------------------
;
CopyByte:
	call	LoadByte			;load byte
	jmp	StoreByte			;store byte
;
;------------------------------------------------------------------------------
;
CopyWord:
	call	LoadWord			;load word
	jmp	StoreWord			;store word
;
;------------------------------------------------------------------------------
;
CopyDword:
	call	LoadDword			;load dword
	jmp	StoreDword			;store dword
;
;------------------------------------------------------------------------------
;
CopySwapWord:
	call	LoadWord			;load word
	xchg	dl,dh				;swap bytes
	jmp	StoreWord			;store word
;
;------------------------------------------------------------------------------
;
CopySwapDword:
	call	LoadDword			;load dword
	xchg	dl,dh				;swap bytes
	rol	edx,16
	xchg	dl,dh
	jmp	StoreDword			;store dword
;
;------------------------------------------------------------------------------
;
CopyByteToWord:
	call	LoadByte			;load byte
	jmp	StoreWord			;store word
;
;------------------------------------------------------------------------------
;
CopyByteToDword:
	call	LoadByte			;load byte
	jmp	StoreDword			;store dword
;
;------------------------------------------------------------------------------
;
CopyWordToDword:
	call	LoadWord			;load word
	jmp	StoreDword			;store dword
;
;==============================================================================
;
;	>	esi  -  source
;		edi  -  destination
;		ecx  -  number of bytes
;
;	<	esi  -  next source
;		edi  -  next destination
;
;	eax, ebx not affected
;
;------------------------------------------------------------------------------
;
CopyDataBlock:
	jecxz	CopyDataBlock2			;no data
CopyDataBlock1:
	call	CopyByte			;copy byte
	loop	CopyDataBlock1			;next byte
CopyDataBlock2:
	ret
;
;------------------------------------------------------------------------------
;
CopyCStringToUpperCase:
	call	LoadByte			;load character
	jecxz	CopyCStringToUpperCase2		;string too long
	cmp	dl,'a'				;lower case character?
	jb	CopyCStringToUpperCase1
	cmp	dl,'z'
	ja	CopyCStringToUpperCase1
	add	dl,'A'-'a'			;convert to upper case
CopyCStringToUpperCase1:
	call	StoreByte			;store character
	dec	ecx
	jnz	CopyCStringToUpperCase2
	cmp	dl,0				;end of string?
	jz	CopyCStringToUpperCase2
	dec	edi				;delete last char in buffer
	inc	ecx
CopyCStringToUpperCase2:
	cmp	dl,0				;end of string?
	jnz	CopyCStringToUpperCase
	ret
;
;------------------------------------------------------------------------------
;
CopyCStringToPascalString:
	push	ebx
	mov	ebx,edi				;set character count pointer
	jecxz	CopyCStringToPascalString1	;no space
	mov	dl,0				;clear character count
	call	StoreByte
	dec	ecx
CopyCStringToPascalString1:
	call	LoadByte			;load character
	cmp	dl,0				;end of string?
	jz	CopyCStringToPascalString2
	jecxz	CopyCStringToPascalString1	;string too long
	add	byte ptr [ebx],1		;modify character count
	sbb	byte ptr [ebx],0		;don't wrap to zero
	jb	CopyCStringToPascalString1	;string too long
	call	StoreByte			;store character
	dec	ecx				;count characters
	jmp	CopyCStringToPascalString1	;next character
CopyCStringToPascalString2:
	pop	ebx
	ret
;
;------------------------------------------------------------------------------
;
CopyPascalStringToCString:
	push	ebx
	call	LoadByte			;load string length
	mov	ebx,esi				;get next data address
	add	ebx,edx
	jecxz	CopyPascalStringToCString3	;no space
CopyPascalStringToCString1:
	cmp	esi,ebx				;end of string?
	jz	CopyPascalStringToCString2
	cmp	ecx,2				;string too long?
	jb	CopyPascalStringToCString2
	call	CopyByte			;copy character
	dec	ecx				;count characters
	jmp	CopyPascalStringToCString1	;next character
CopyPascalStringToCString2:
	mov	dl,0				;terminate string
	call	StoreByte
	dec	ecx
CopyPascalStringToCString3:
	mov	esi,ebx				;next data
	pop	ebx
	ret
;
;==============================================================================
;
;	>	esi  -  source
;		ecx  -  offset
;
;	<	esi  -  source
;		ecx  -  next offset
;
;	eax, ebx, edi not affected
;
;------------------------------------------------------------------------------
;
SwapWord:
	mov	dx,[esi+ecx]			;load word
	xchg	dl,dh				;swap bytes
	mov	[esi+ecx],dx			;store word
	add	ecx,2				;next offset
	ret
;
;------------------------------------------------------------------------------
;
SwapDword:
	mov	edx,[esi+ecx]			;load dword
	xchg	dl,dh				;swap bytes
	rol	edx,16
	xchg	dl,dh
	mov	[esi+ecx],edx			;store dword
	add	ecx,4				;next offset
	ret
;
;==============================================================================
;
;	>	esi  -  source
;
;	<	esi  -  next source
;		edx  -  data
;
;	eax, ebx, ecx, edi not affected
;
;------------------------------------------------------------------------------
;
LoadByte:
	cmp	esi,NULL			;source not defined?
	mov	edx,0
	jz	LoadByte1
	movzx	edx,byte ptr [esi]		;load byte
	inc	esi
LoadByte1:
	ret
;
;------------------------------------------------------------------------------
;
LoadWord:
	cmp	esi,NULL			;source not defined?
	mov	edx,0
	jz	LoadWord1
	movzx	edx,word ptr [esi]		;load word
	add	esi,2
LoadWord1:
	ret
;
;------------------------------------------------------------------------------
;
LoadDword:
	cmp	esi,NULL			;source not defined?
	mov	edx,0
	jz	LoadDword1
	mov	edx,[esi]			;load dword
	add	esi,4
LoadDword1:
	ret
;
;==============================================================================
;
;	>	edi  -  destination
;		edx  -  data
;
;	<	edi  -  next destination
;
;	eax, ebx, ecx, esi not affected
;
;------------------------------------------------------------------------------
;
StoreByte:
	cmp	edi,NULL			;destination not defined?
	jz	StoreByte1
	mov	[edi],dl			;store byte
	inc	edi
StoreByte1:
	ret
;
;------------------------------------------------------------------------------
;
StoreWord:
	cmp	edi,NULL			;destination not defined?
	jz	StoreWord1
	mov	[edi],dx			;store word
	add	edi,2
StoreWord1:
	ret
;
;------------------------------------------------------------------------------
;
StoreDword:
	cmp	edi,NULL			;destination not defined?
	jz	StoreDword1
	mov	[edi],edx			;store dword
	add	edi,4
StoreDword1:
	ret
;
;==============================================================================
;
;	SUPPORT ROUTINES
;
;==============================================================================
;
;	>	esi  -  server name (ansi)
;
;	<	edi  -  connection handle (NULL = error)
;
;------------------------------------------------------------------------------
;
CreateConnectionHandle:
	mov	ecx,esi				;seek end of string
CreateConnectionHandle1:
	inc	ecx
	cmp	byte ptr [ecx-1],0
	jnz	CreateConnectionHandle1
	sub	ecx,esi				;compute buffer length
	inc	ecx
	inc	ecx
	shl	ecx,1
	push	esi
	push	ecx
	add	ecx,NWCONN_HANDLE_STRUCTURE_	;allocate buffer
	Win32	LocalAlloc,\
		LMEM_FIXED+LMEM_ZEROINIT,\
		ecx
	mov	edi,eax
	pop	ecx
	pop	esi
	cmp	edi,NULL			;allocation error?
	jz	CreateConnectionHandle3
	lea	ebx,[edi+NWCONN_HANDLE_STRUCTURE_] ;load string data address
	mov	[edi.ch_Buffer],ebx		;set buffer pointer
	mov	[edi.ch_MaximumLength],cx	;set maximum length
	dec	ecx				;set string length
	dec	ecx
	mov	[edi.ch_Length],cx
	mov	[edi.ch_Handle],INVALID_HANDLE_VALUE ;clear device handle
	mov	ah,0				;clear hi byte of unicode char
	mov	al,"\"				;load server prefix char
	mov	[ebx],ax			;store unicode character
	inc	ebx
	inc	ebx
	mov	[ebx],ax			;store unicode character
	inc	ebx
	inc	ebx
CreateConnectionHandle2:
	mov	al,[esi]			;load ansi character
	inc	esi
	mov	[ebx],ax			;store unicode character
	inc	ebx
	inc	ebx
	cmp	al,0				;end of string?
	jnz	CreateConnectionHandle2
CreateConnectionHandle3:
	ret
;
;==============================================================================
;
;	>	ecx  -  extra bytes
;
;	<	edx  -  control block structure (NULL = error)
;		esi  -  object attributes
;		edi  -  i/o status block
;		ebx  -  extra data
;
;------------------------------------------------------------------------------
;
CreateControlBlocks:
	add	ecx,OBJECT_ATTRIBUTES_+IO_STATUS_BLOCK_
	Win32	LocalAlloc,\			;allocate buffer
		LMEM_FIXED+LMEM_ZEROINIT,\
		ecx
	mov	edx,eax
	cmp	edx,NULL			;allocation error?
	jz	CreateControlBlocks1
	lea	esi,[edx]			;load pointers
	lea	edi,[esi+OBJECT_ATTRIBUTES_]
	lea	ebx,[edi+IO_STATUS_BLOCK_]
CreateControlBlocks1:
	ret
;
;==============================================================================
;
;	>	esi  -  ansi string
;
;	<	edi  -  unicode string structure (NULL = error)
;
;------------------------------------------------------------------------------
;
CreateUnicodeString:
	mov	ecx,esi				;seek end of string
CreateUnicodeString1:
	inc	ecx
	cmp	byte ptr [ecx-1],0
	jnz	CreateUnicodeString1
	sub	ecx,esi				;compute buffer length
	shl	ecx,1
	push	esi
	push	ecx
	call	CreateString			;create string structure
	pop	ecx
	pop	esi
	cmp	edi,NULL			;error?
	jz	CreateUnicodeString3
	dec	ecx				;set string length
	dec	ecx
	mov	[edi.ss_Length],cx
	mov	ah,0				;clear hi byte of unicode char
CreateUnicodeString2:
	mov	al,[esi]			;load ansi character
	inc	esi
	mov	[ebx],ax			;store unicode character
	inc	ebx
	inc	ebx
	cmp	al,0				;end of string?
	jnz	CreateUnicodeString2
CreateUnicodeString3:
	ret
;
;==============================================================================
;
;	>	ecx  -  buffer length
;
;	<	edi  -  string structure (NULL = error)
;		ebx  -  string data
;
;------------------------------------------------------------------------------
;
CreateString:
	cmp	ecx,00010000h			;maximum length exceeded?
	mov	edi,NULL
	jnb	CreateString1
	push	ecx
	add	ecx,STRING_STRUCTURE_		;allocate buffer
	Win32	LocalAlloc,\
		LMEM_FIXED+LMEM_ZEROINIT,\
		ecx		
	mov	edi,eax
	pop	ecx
	cmp	edi,NULL			;allocation error?
	jz	CreateString1
	lea	ebx,[edi+STRING_STRUCTURE_]	;load string data address
	mov	[edi.ss_Buffer],ebx		;set buffer pointer
	mov	[edi.ss_MaximumLength],cx	;set maximum length
	mov	[edi.ss_Length],0		;clear string length
CreateString1:
	ret
;
;==============================================================================
;
;	>	esi  -  ansi string
;
;	<	ecx  -  number of characters
;
;------------------------------------------------------------------------------
;
GetAnsiStringLength:
	mov	ecx,-1				;init character count
GetAnsiStringLength1:
	inc	ecx				;find end of string
	cmp	byte ptr [esi+ecx],0
	jnz	GetAnsiStringLength1
	ret
;
;==============================================================================
;
EndCode
;
;==============================================================================
;==============================================================================
;====== .DATA SECTION =========================================================
;==============================================================================
;==============================================================================
;
BeginData
;
;==============================================================================
;
;	INITIALIZED DATA
;
;------------------------------------------------------------------------------
;
sMainCaption:		STRING	<32-Bit NetWare API DLL/0>
sDeviceNwrdr:		ASTRING	</|Device/|Nwrdr/0>
;
;------------------------------------------------------------------------------
;
NcpGetBinderyObjectId:
REQUEST_RECORD {NCP_GET_BINDERY_OBJECT_ID,\
		2+NW_MAX_OBJECT_NAME_LEN, 4+2+NW_MAX_OBJECT_NAME_LEN}
;
NcpGetBinderyObjectName:
REQUEST_RECORD {NCP_GET_BINDERY_OBJECT_NAME,\
		4, 4+2+NW_MAX_OBJECT_NAME_LEN}
;
NcpGetEncryptionKey:
REQUEST_RECORD {NCP_GET_ENCRYPTION_KEY,\
		0, NWLOGIN_KEY_}
;
NcpGetFileServerDateAndTime:
REQUEST_RECORD {NCP_GET_FILE_SERVER_DATE_AND_TIME,\
		0, NWDATE_TIME_}
;
NcpGetFileServerInformation:
REQUEST_RECORD {NCP_GET_FILE_SERVER_INFORMATION,\
		0, VERSION_INFO_}
;
NcpGetInternetAddress:
REQUEST_RECORD {NCP_GET_INTERNET_ADDRESS,\
		4, NWINTERNET_ADDR_+1}
;
NcpGetStationLoggedInformation:
REQUEST_RECORD {NCP_GET_STATION_LOGGED_INFORMATION,\
		4, 4+2+NW_MAX_OBJECT_NAME_LEN+NWDATE_TIME_+1}
;
NcpGetStationNumber:
REQUEST_RECORD {NCP_GET_STATION_NUMBER,\
		0, 3}
;
NcpGetUtcTime:
REQUEST_RECORD {NCP_GET_UTC_TIME,\
		0, 100}
;
NcpGetVolumeName:
REQUEST_RECORD {NCP_GET_VOLUME_NAME,\
		1, NW_MAX_VOLUME_NAME_LEN}
;
NcpLoginObject:
REQUEST_RECORD {NCP_LOGIN_OBJECT,\
		2+NW_MAX_OBJECT_NAME_LEN+NW_MAX_PASSWORD_LEN, 0}
;
NcpLoginObjectEncrypted:
REQUEST_RECORD {NCP_LOGIN_OBJECT_ENCRYPTED,\
		NWLOGIN_KEY_+2+NW_MAX_OBJECT_NAME_LEN, 0}
;
NcpLoginUserObject:
REQUEST_RECORD {NCP_LOGIN_USER_OBJECT,\
		NW_MAX_OBJECT_NAME_LEN+NW_MAX_PASSWORD_LEN, 0}
;
NcpLogout:
REQUEST_RECORD {NCP_LOGOUT,\
		0, 0}
;
;------------------------------------------------------------------------------
;
dDaysPerMonth:
	BYTE	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
;
;------------------------------------------------------------------------------
;
EncryptionTable1:
	BYTE	048h,093h,046h,067h,098h,03Dh,0E6h,08Dh
	BYTE	0B7h,010h,07Ah,026h,05Ah,0B9h,0B1h,035h
	BYTE	06Bh,00Fh,0D5h,070h,0AEh,0FBh,0ADh,011h
	BYTE	0F4h,047h,0DCh,0A7h,0ECh,0CFh,050h,0C0h
;
EncryptionTable2:
	BYTE	07h,08h,00h,08h,06h,04h,0Eh,04h,05h,0Ch,01h,07h,0Bh,0Fh,0Ah,08h
	BYTE	0Fh,08h,0Ch,0Ch,09h,04h,01h,0Eh,04h,06h,02h,04h,00h,0Ah,0Bh,09h
	BYTE	02h,0Fh,0Bh,01h,0Dh,02h,01h,09h,05h,0Eh,07h,00h,00h,02h,06h,06h
	BYTE	00h,07h,03h,08h,02h,09h,03h,0Fh,07h,0Fh,0Ch,0Fh,06h,04h,0Ah,00h
	BYTE	02h,03h,0Ah,0Bh,0Dh,08h,03h,0Ah,01h,07h,0Ch,0Fh,01h,08h,09h,0Dh
	BYTE	09h,01h,09h,04h,0Eh,04h,0Ch,05h,05h,0Ch,08h,0Bh,02h,03h,09h,0Eh
	BYTE	07h,07h,06h,09h,0Eh,0Fh,0Ch,08h,0Dh,01h,0Ah,06h,0Eh,0Dh,00h,07h
	BYTE	07h,0Ah,00h,01h,0Fh,05h,04h,0Bh,07h,0Bh,0Eh,0Ch,09h,05h,0Dh,01h
	BYTE	0Bh,0Dh,01h,03h,05h,0Dh,0Eh,06h,03h,00h,0Bh,0Bh,0Fh,03h,06h,04h
	BYTE	09h,0Dh,0Ah,03h,01h,04h,09h,04h,08h,03h,0Bh,0Eh,05h,00h,05h,02h
	BYTE	0Ch,0Bh,0Dh,05h,0Dh,05h,0Dh,02h,0Dh,09h,0Ah,0Ch,0Ah,00h,0Bh,03h
	BYTE	05h,03h,06h,09h,05h,01h,0Eh,0Eh,00h,0Eh,08h,02h,0Dh,02h,02h,00h
	BYTE	04h,0Fh,08h,05h,09h,06h,08h,06h,0Bh,0Ah,0Bh,0Fh,00h,07h,02h,08h
	BYTE	0Ch,07h,03h,0Ah,01h,04h,02h,05h,0Fh,07h,0Ah,0Ch,0Eh,05h,09h,03h
	BYTE	0Eh,07h,01h,02h,0Eh,01h,0Fh,04h,0Ah,06h,0Ch,06h,0Fh,04h,03h,00h
	BYTE	0Ch,00h,03h,06h,0Fh,08h,07h,0Bh,02h,0Dh,0Ch,06h,0Ah,0Ah,08h,0Dh
;
;------------------------------------------------------------------------------
;
NWCCodeTable:
	DWORD	STATUS_SUCCESS,			NWCCODE_SUCCESSFUL
	DWORD	STATUS_ACCESS_DENIED,		NWCCODE_ACCESS_DENIED
	DWORD	STATUS_DATA_ERROR,		NWCCODE_NET_RECV_ERROR
	DWORD	STATUS_INSUFF_SERVER_RESOURCES,	NWCCODE_SERVER_OUT_OF_MEMORY
	DWORD	STATUS_INVALID_HANDLE,		NWCCODE_BAD_DIRECTORY_HANDLE
	DWORD	STATUS_INVALID_PARAMETER,	NWCCODE_INVALID_PARAMETER
	DWORD	STATUS_NO_MEMORY,		NWCCODE_NO_MEMORY
	DWORD	STATUS_NO_MORE_ENTRIES,		NWCCODE_NO_MORE_ENTRIES
	DWORD	STATUS_NO_SUCH_DEVICE,		NWCCODE_VOLUME_DOES_NOT_EXIST
	DWORD	STATUS_OBJECT_PATH_NOT_FOUND,	NWCCODE_INVALID_PATH
	DWORD	STATUS_UNSUCCESSFUL,		NWCCODE_INVALID_CONNECTION
	DWORD	STATUS_UNDEFINED,		NWCCODE_UNDEFINED
;
;==============================================================================
;
EndIData
;
;==============================================================================
;
;	UNINITIALIZED DATA
;
;------------------------------------------------------------------------------
;
OsVersionInfo		OSVERSIONINFO {}
sLoadFile		CHAR MAX_PATH dup (?)
;
;------------------------------------------------------------------------------
;
hInst			HINSTANCE ?	
;
;==============================================================================
;
EndUData
;
;==============================================================================
;
EndImage

