;
;	________________________________________________________________
;
;	                          NW_Info.asm
;	                   NetWare Server Info V1.00
;	        06-21-1996 Sven B. Schreiber sbs@psbs.franken.de
;	                 This is Public Domain Software
;	________________________________________________________________
;
;
;
;==============================================================================
;
; Assembly Instructions
; ---------------------
;
; Use MASM 6.11 to assemble this file.
; Recommended MASM command line: ml /I. /Zm /c /Cp /Ta NW_Info.asm
;
;==============================================================================
;
; Disclaimer
; ----------
;
; This software is provided "as is" and any express or implied warranties,
; including, but not limited to, the implied warranties of merchantibility and
; fitness for a particular purpose are disclaimed. In no event shall the
; author Sven B. Schreiber be liable for any direct, indirect, incidental,
; special, exemplary, or consequential damages (including, but not limited to,
; procurement of substitute goods or services; loss of use, data, or profits;
; or business interruption) however caused and on any theory of liability,
; whether in contract, strict liability, or tort (including negligence or
; otherwise) arising in any way out of the use of this software, even if
; advised of the possibility of such damage.
;
;==============================================================================
;
CONSOLE			equ	1		;0 = gui, 1 = console
UNICODE			equ	0		;0 = ansi, 1 = unicode
DLL			equ	0		;0 = application, 1 = dll
WIN95			equ	0		;0 = windows nt, 1 = windows 95
;
;==============================================================================
;
	include	W32Main.inc			;Win32 main header file
;
;==============================================================================
;
IMPORT			"NT", "SBS"		;import library list
;
;------------------------------------------------------------------------------
;
DEFAULT_ICON		equ	101		;application icon id
;
;==============================================================================
;
;	CONSTANTS
;
;==============================================================================
;
LF			equ	0Ah		;linefeed
CR			equ	0Dh		;carriage return
;
;==============================================================================
;
;	MAIN SEGMENT
;
;==============================================================================
;
BeginImage	_main, text, data
;
;==============================================================================
;
;	.TEXT SECTION
;
;==============================================================================
;
BeginCode
;
;------------------------------------------------------------------------------
;
	include	W32Start.inc			;Win32 startup code
;
;==============================================================================
;
;	MAIN PROGRAM BODY
;
;==============================================================================
;
;	>	[esp+04]  ->  [ebp+08]  -  hInstance
;		[esp+08]  ->  [ebp+12]  -  pEnvironment
;		[esp+12]  ->  [ebp+16]  -  pCmdLine
;		[esp+16]  ->  [ebp+20]  -  dCmdShow
;
;	<			   eax  -  return code
;
;------------------------------------------------------------------------------
;
WinMain:
	WinMainPrologue
	Win32	GetStdHandle,\			;get standard input handle
		STD_INPUT_HANDLE
	mov	hStdInput,eax
	cmp	eax,INVALID_HANDLE_VALUE
	jz	WinMain2
	Win32	GetStdHandle,\			;get standard output handle
		STD_OUTPUT_HANDLE
	mov	hStdOutput,eax
	cmp	eax,INVALID_HANDLE_VALUE
	jz	WinMain2
	Win32	GetStdHandle,\			;get standard error handle
		STD_ERROR_HANDLE
	mov	hStdError,eax
	cmp	eax,INVALID_HANDLE_VALUE
	jz	WinMain2
	mov	esi,offset sBanner		;display banner
	call	OutputString
	call	ParseCommandLine		;parse command line
	jb	WinMain1
	call	OpenConnection			;open server connection
	jb	WinMain1
	call	DisplayServerInfo		;display server info
	call	DisplayConnectionNumber		;display connection number
	call	DisplayObjectInfo		;display object name
	call	DisplayServerDateAndTime	;display server date and time
	call	DisplayUtcDateAndTime		;display utc date and time
	call	DisplayVolumeNames		;display volume names
	call	CloseConnection			;close server connection
WinMain1:
	jmp	WinMain3
WinMain2:
	call	OutputErrorMessage		;display error message
WinMain3:
	mov	eax,0				;load return code
	WinMainEpilogue
;
;==============================================================================
;
;	<	c  -  set if error
;
;------------------------------------------------------------------------------
;
ParseCommandLine:
	mov	esi,pCmdLine			;load command line
	mov	edi,NULL			;skip program name
	mov	ecx,0
	call	GetCommandParameter
	jb	ParseCommandLine2
	mov	edi,offset sServer		;get server name
	mov	ecx,NW_MAX_SERVER_NAME_LEN
	call	GetCommandParameter
	jb	ParseCommandLine2
	mov	edi,offset sLoginName		;get login name
	mov	ecx,NW_MAX_OBJECT_NAME_LEN
	call	GetCommandParameter
	jb	ParseCommandLine2
	mov	edi,offset sLoginPassword	;get login password
	mov	ecx,NW_MAX_PASSWORD_LEN
	call	GetCommandParameter
	jb	ParseCommandLine2
	cmp	sServer,0			;server name specified?
	clc
	jnz	ParseCommandLine2
ParseCommandLine1:
	mov	esi,offset sUsage		;display usage info
	call	OutputString
	stc					;error
ParseCommandLine2:
	ret
;
;==============================================================================
;
;	>	esi  -  command tail
;		edi  -  parameter buffer
;		ecx  -  number of characters
;
;	<	esi  -  remaining command tail
;		  c  -  set if error
;
;------------------------------------------------------------------------------
;
GetCommandParameter:
	lodc	[esi]				;skip leading spaces
	cmpc	" "
	jnz	GetCommandParameter1
	incc	esi
	jmp	GetCommandParameter
GetCommandParameter1:
	lodc	[esi]				;load character
	incc	esi
	cmpc	" "				;parameter separator?
	jnz	GetCommandParameter2
	lodc	0				;substitute
GetCommandParameter2:
	cmp	edi,NULL			;no destination specified?
	jz	GetCommandParameter3
	cmp	ecx,1				;buffer overflow?
	jb	GetCommandParameter4
	stoc	[edi]				;save character
	incc	edi
	dec	ecx
GetCommandParameter3:
	cmpc	0				;end of command tail?
	jnz	GetCommandParameter1
	decc	esi				;back 1 character
	clc					;ok
GetCommandParameter4:
	ret
;
;==============================================================================
;
;	<	c  -  set if error
;
;------------------------------------------------------------------------------
;
OpenConnection:
	mov	edi,offset sAttachInfo		;display attach info
	mov	esi,offset sServer
	call	OutputEmbeddedString
	Win32	NWAttachToFileServer,\		;open server connection
		<offset sServer>,\
		0,\
		<offset dConnectionHandle>
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sAttachFailure
	jnz	OpenConnection1
	cmp	sLoginName,0			;no login name specified?
	clc
	jz	OpenConnection2
	mov	edi,offset sLoginInfo		;display login info
	mov	esi,offset sServer
	call	OutputEmbeddedString
	mov	esi,offset sLoginName
	call	OutputEmbeddedString
	Win32	NWLoginToFileServer,\		;login
		dConnectionHandle,\
		<offset sLoginName>,\
		OT_USER,\
		<offset sLoginPassword>
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	clc
	jz	OpenConnection2
	Win32	NWDetachFromFileServer,\	;close server connection
		dConnectionHandle
	mov	esi,offset sLoginFailure	;display error message
OpenConnection1:
	call	OutputString
	stc					;error
OpenConnection2:
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
CloseConnection:
	cmp	sLoginName,0			;no login name specified?
	jz	CloseConnection1
	Win32	NWLogoutFromFileServer,\	;logout
		dConnectionHandle
CloseConnection1:
	Win32	NWDetachFromFileServer,\	;close server connection
		dConnectionHandle
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayServerInfo:
	Win32	NWGetFileServerVersionInfo,\	;get server info
		dConnectionHandle,\
		<offset VersionInfo>
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerInfo1
	lea	esi,VersionInfo.vi_serverName	;display server name
DisplayServerInfo1:
	mov	edi,offset sServerName
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerInfo2
	mov	edi,offset sVersionNumber	;file service version -> text
	mov	ah,VersionInfo.vi_fileServiceVersion
	mov	al,VersionInfo.vi_fileServiceSubVersion
	call	MakeVersionString
	lea	esi,sVersionNumber		;display file service version
DisplayServerInfo2:
	mov	edi,offset sFileServiceVersion
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerInfo3
	mov	edi,offset sHexNumber16		;max connections -> hex
	mov	ax,VersionInfo.vi_maximumServiceConnections
	call	WordToHex
	lea	esi,sHexNumber16		;display max connections
DisplayServerInfo3:
	mov	edi,offset sMaxConnections
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerInfo4
	mov	edi,offset sHexNumber16		;peak count -> hex
	mov	ax,VersionInfo.vi_maxConnectionsEverUsed
	call	WordToHex
	lea	esi,sHexNumber16		;display peak count
DisplayServerInfo4:
	mov	edi,offset sPeakConnections
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerInfo5
	mov	edi,offset sHexNumber16		;used connections -> hex
	mov	ax,VersionInfo.vi_connectionsInUse
	call	WordToHex
	lea	esi,sHexNumber16		;display used connections
DisplayServerInfo5:
	mov	edi,offset sUsedConnections
	call	OutputEmbeddedString
	pop	eax
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayConnectionNumber:
	Win32	NWGetConnectionNumber,\		;get connection number
		dConnectionHandle,\
		<offset wConnectionNumber>
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayConnectionNumber1
	mov	edi,offset sHexNumber16		;connection number -> hex
	mov	ax,wConnectionNumber
	call	WordToHex
	mov	esi,offset sHexNumber16		;display connection number
DisplayConnectionNumber1:
	mov	edi,offset sConnectionNumber
	call	OutputEmbeddedString
	pop	eax
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayObjectInfo:
	movzx	eax,wConnectionNumber		;get connection info
	Win32	NWGetConnectionInformation,\
		dConnectionHandle,\
		eax,\
		<offset sObjectNameBuffer>,\
		<offset wObjectType>,\
		<offset dObjectId>,\
		<offset LoginTime>
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayObjectInfo1
	mov	esi,offset sObjectNameBuffer	;display object name
DisplayObjectInfo1:
	mov	edi,offset sObjectName
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayObjectInfo2
	mov	edi,offset sHexNumber16		;object type -> hex
	mov	ax,wObjectType
	call	WordToHex
	mov	esi,offset sHexNumber16		;display object type
DisplayObjectInfo2:
	mov	edi,offset sObjectType
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayObjectInfo3
	mov	edi,offset sHexNumber32		;object id -> hex
	mov	eax,dObjectId
	call	DwordToHex
	mov	esi,offset sHexNumber32		;display object id
DisplayObjectInfo3:
	mov	edi,offset sObjectId
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayObjectInfo4
	mov	edi,offset sLongDate		;login date -> text
	mov	esi,offset LoginTime
	call	MakeLongDateString
	mov	esi,offset sLongDate		;display login date
DisplayObjectInfo4:
	mov	edi,offset sLoginTime
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	jnz	DisplayObjectInfo5
	push	edi
	mov	edi,offset sTime		;login time -> text
	mov	esi,offset LoginTime
	call	MakeTimeString
	pop	edi
	mov	esi,offset sTime		;display login time
	call	OutputEmbeddedString
DisplayObjectInfo5:
	pop	eax
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayServerDateAndTime:
	Win32	NWGetFileServerDateAndTime,\	;get server date and time
		dConnectionHandle,\
		<offset ServerTime>
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayServerDateAndTime1
	mov	edi,offset sLongDate		;server date -> text
	mov	esi,offset ServerTime
	call	MakeLongDateString
	mov	esi,offset sLongDate		;display server date
DisplayServerDateAndTime1:
	mov	edi,offset sServerTime
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	jnz	DisplayServerDateAndTime2
	push	edi
	mov	edi,offset sTime		;server time -> text
	mov	esi,offset ServerTime
	call	MakeTimeString
	pop	edi
	mov	esi,offset sTime		;display server time
	call	OutputEmbeddedString
DisplayServerDateAndTime2:
	pop	eax
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayUtcDateAndTime:
	Win32	NWGetFileServerUTCTime,\	;get utc date and time
		dConnectionHandle,\
		<offset dUtcTime>
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayUtcDateAndTime1
	push	eax
	Win32	NwlibUTCTimeToDateAndTime,\	;convert utc time
		dUtcTime,\
		<offset UtcTime>
	pop	eax
DisplayUtcDateAndTime1:
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	mov	esi,offset sUnknown
	jnz	DisplayUtcDateAndTime2
	mov	edi,offset sLongDate		;utc date -> text
	mov	esi,offset UtcTime
	call	MakeLongDateString
	mov	esi,offset sLongDate		;display utc date
DisplayUtcDateAndTime2:
	mov	edi,offset sUtcTime
	call	OutputEmbeddedString
	pop	eax
	push	eax
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	jnz	DisplayUtcDateAndTime3
	push	edi
	mov	edi,offset sTime		;utc time -> text
	mov	esi,offset UtcTime
	call	MakeTimeString
	pop	edi
	mov	esi,offset sTime		;display utc time
	call	OutputEmbeddedString
DisplayUtcDateAndTime3:
	pop	eax
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
DisplayVolumeNames:
	mov	esi,offset sServerVolumes	;display caption
	call	OutputString
	mov	eax,0				;clear volume index
	mov	ecx,0				;clear volume count
DisplayVolumeNames1:
	push	eax
	push	ecx
	Win32	NWGetVolumeName,\		;get volume name
		dConnectionHandle,\
		eax,\
		<offset sVolumeNameBuffer>
	cmp	eax,NWCCODE_SUCCESSFUL		;error?
	jnz	DisplayVolumeNames2
	cmp	sVolumeNameBuffer,0		;valid volume name?
	jz	DisplayVolumeNames2
	pop	ecx
	inc	ecx				;count volumes
	push	ecx
	mov	esi,offset sVolumeNameBuffer	;display volume name
	mov	edi,offset sVolumeName
	call	OutputEmbeddedString
DisplayVolumeNames2:
	pop	ecx
	pop	eax
	inc	eax				;next volume index
	cmp	eax,NW_MAX_VOLUMES
	jnz	DisplayVolumeNames1
	jecxz	DisplayVolumeNames3		;no volumes found
	mov	esi,offset sNewLine		;new line
	call	OutputString
DisplayVolumeNames3:
	ret
;
;==============================================================================
;
;	no parameters
;
;------------------------------------------------------------------------------
;
OutputErrorMessage:
	Win32	GetLastError			;get error code
	mov	pMessageBuffer,NULL		;clear message buffer pointer
	Win32	FormatMessage,\			;get error message
		FORMAT_MESSAGE_FROM_SYSTEM+FORMAT_MESSAGE_ALLOCATE_BUFFER,\
		NULL,\
		eax,\
		LANG_NEUTRAL+SUBLANG_DEFAULT,\
		<offset pMessageBuffer>,\
		0,\
		NULL
	mov	esi,offset sNoErrorMessage	;load default message
	mov	ebx,pMessageBuffer		;test error message
	cmp	ebx,NULL			;no message?
	jz	OutputErrorMessage1
	cmp	CHAR ptr [ebx],0		;null message?
	jz	OutputErrorMessage1
	mov	esi,ebx				;load system message
OutputErrorMessage1:
	push	esi
	mov	esi,offset sNewLine		;new line
	call	OutputString
	pop	esi
	call	OutputString			;display error message
	cmp	pMessageBuffer,NULL		;message buffer allocated?
	jz	OutputErrorMessage2
	Win32	LocalFree,\			;deallocate message buffer
		pMessageBuffer
OutputErrorMessage2:
	ret
;
;==============================================================================
;
;	>	esi  -  embedded string
;		edi  -  frame string
;
;	<	esi  -  next embedded string address
;		edi  -  next frame string address
;
;------------------------------------------------------------------------------
;
OutputEmbeddedString:
	push	esi
	mov	esi,edi				;begin frame string
	call	OutputString
	mov	edi,esi
	pop	esi
	push	edi
	call	OutputString			;insert embedded string
	pop	edi
	push	esi
	mov	esi,edi				;end frame string
	call	OutputString
	mov	edi,esi
	pop	esi
	ret
;
;==============================================================================
;
;	>	esi  -  string
;
;	<	esi  -  next string address
;
;------------------------------------------------------------------------------
;
OutputString:
;
	if	UNICODE
	push	esi
	Win32	WideCharToMultiByte,\		;convert unicode -> ansi
		CP_ACP,\
		0,\
		esi,\
		-1,\
		NULL,\
		0,\
		NULL,\
		NULL
	mov	ecx,eax
	push	ecx
	Win32	LocalAlloc,\
		LMEM_FIXED,\
		ecx
	pop	ecx
	pop	esi
	cmp	eax,NULL
	jz	OutputString3
	push	eax
	push	esi
	Win32	WideCharToMultiByte,\		;convert unicode -> ansi
		CP_ACP,\
		0,\
		esi,\
		-1,\
		eax,\
		ecx,\
		NULL,\
		NULL
	pop	esi
	shl	eax,1				;compute next address
	add	esi,eax
	pop	eax
	push	esi
	push	eax
	mov	esi,eax				;use ansi string
	endif
;
	mov	ebx,esi				;seek string terminator
OutputString1:
	inc	ebx
	cmp	byte ptr [ebx-1],0
	jnz	OutputString1
	push	ebx
	dec	ebx				;compute string length
	sub	ebx,esi
	jz	OutputString2
	Win32	WriteFile,\			;display string
		hStdOutput,\
		esi,\
		ebx,\
		<offset dWriteFileCount>,\
		NULL
OutputString2:
	pop	esi				;load next address
;
	if	UNICODE
	pop	eax
	Win32	LocalFree,\
		eax
	pop	esi				;load next address
OutputString3:
	endif
;
	ret
;
;==============================================================================
;
;	>	edi  -  destination
;		esi  -  date/time structure
;
;	<	edi  -  next destination
;
;------------------------------------------------------------------------------
;
MakeLongDateString:
	mov	dl,[esi.dt_Month]		;write month
	mov	dh,"-"
	call	MakeLongDateString1
	mov	dl,[esi.dt_Day]			;write day
	mov	dh,"-"
	call	MakeLongDateString1
	mov	al,[esi.dt_Year]		;compute year
	mov	ah,0
	add	ax,1900
	mov	dl,100				;split
	div	dl
	mov	bx,ax
	mov	dl,bl				;write century
	mov	dh,-1
	call	MakeLongDateString1
	mov	dl,bh				;write year in century
	mov	dh,0
MakeLongDateString1:
	mov	al,dl				;split tens from ones
	mov	ah,0
	mov	dl,10
	div	dl
	add	ax,"00"				;binary -> ansi
	mov	CHAR ptr [edi],0		;write tens
	mov	[edi],al
	add	edi,CHAR_
	mov	CHAR ptr [edi],0		;write ones
	mov	[edi],ah
	add	edi,CHAR_
	cmp	dh,-1				;no separator?
	jz	MakeLongDateString2
	mov	CHAR ptr [edi],0		;write separator
	mov	[edi],dh
	add	edi,CHAR_
MakeLongDateString2:
	ret
;
;==============================================================================
;
;	>	edi  -  destination
;		esi  -  date/time structure
;
;	<	edi  -  next destination
;
;------------------------------------------------------------------------------
;
MakeTimeString:
	mov	dl,[esi.dt_Hour]		;write hour
	mov	dh,":"
	call	MakeTimeString1
	mov	dl,[esi.dt_Minute]		;write minute
	mov	dh,":"
	call	MakeTimeString1
	mov	dl,[esi.dt_Second]		;write second
	mov	dh,0
MakeTimeString1:
	mov	al,dl				;split tens from ones
	mov	ah,0
	mov	dl,10
	div	dl
	add	ax,"00"				;binary -> ansi
	mov	CHAR ptr [edi],0		;write tens
	mov	[edi],al
	add	edi,CHAR_
	mov	CHAR ptr [edi],0		;write ones
	mov	[edi],ah
	add	edi,CHAR_
	cmp	dh,-1				;no separator?
	jz	MakeTimeString2
	mov	CHAR ptr [edi],0		;write separator
	mov	[edi],dh
	add	edi,CHAR_
MakeTimeString2:
	ret
;
;==============================================================================
;
;	>	edi  -  destination
;		 ah  -  major version number
;		 al  -  minor version number
;
;	<	edi  -  next destination
;
;------------------------------------------------------------------------------
;
MakeVersionString:
	mov	ebx,eax
	mov	dl,bh				;write major version number
	mov	dh,"."
	call	MakeVersionString1
	mov	dl,bl				;write major version number
	mov	dh,0
MakeVersionString1:
	mov	cl,10				;load decimal divisor
	mov	al,dl				;get ones
	mov	ah,0
	div	cl
	mov	dl,ah
	mov	ah,0				;get tens and hundreds
	div	cl
	cmp	al,0				;0 * 100?
	jz	MakeVersionString2
	add	al,"0"				;write digit
	mov	[edi],al
	inc	edi
MakeVersionString2:
	cmp	ah,0				;0 * 10?
	jz	MakeVersionString3
	add	ah,"0"				;write digit
	mov	[edi],ah
	inc	edi
MakeVersionString3:
	add	dl,"0"				;write digit and separator
	mov	[edi],dx
	add	edi,2
	ret
;
;==============================================================================
;
;	>	    edi  -  destination
;		edx:eax  -  number
;
;	<	    edi  -  next destination
;
;------------------------------------------------------------------------------
;
QwordToHex:
	mov	ecx,MAX_HEX_64-1		;display 64-bit number
	jmp	BinaryToHex
;
;==============================================================================
;
;	>	edi  -  destination
;		eax  -  number
;
;	<	edi  -  next destination
;
;------------------------------------------------------------------------------
;
DwordToHex:
	mov	ecx,MAX_HEX_32-1		;display 32-bit number
	jmp	BinaryToHex
;
;==============================================================================
;
;	>	edi  -  destination
;		 ax  -  number
;
;	<	edi  -  next destination
;
;------------------------------------------------------------------------------
;
WordToHex:
	mov	ecx,MAX_HEX_16-1		;display 16-bit number
	jmp	BinaryToHex
;
;==============================================================================
;
;	>	    edi  -  destination
;		edx:eax  -  binary number
;		    ecx  -  number of characters
;
;	<	    edi  -  next destination
;
;------------------------------------------------------------------------------
;
BinaryToHex:
	lea	edi,[edi+ecx*CHAR_]		;terminate string
	mov	CHAR ptr [edi],0
	mov	esi,edi				;write backwards
BinaryToHex1:
	mov	bl,al				;get next nibble
	and	bl,00001111b
	cmp	bl,10				;0..9?
	mov	bh,'0'
	jb	BinaryToHex2
	mov	bh,'A'-10			;A..F
BinaryToHex2:
	add	bl,bh				;binary -> ansi
	decc	esi				;next character
	mov	CHAR ptr [esi],0		;clear character
	mov	byte ptr [esi],bl		;save character
	shrd	eax,edx,4			;shift in next nibble
	shr	edx,4
	loop	BinaryToHex1
	ret
;
;==============================================================================
;
EndCode
;
;==============================================================================
;
;	.DATA SECTION
;
;==============================================================================
;
BeginData
;
;==============================================================================
;
;	INITIALIZED DATA
;
;------------------------------------------------------------------------------
;
sBanner:
STRING </n>
STRING <________________________________________________________________/n>
STRING </n>
STRING <                          NW_Info.asm/n>
STRING <                   NetWare Server Info V1.00/n>
STRING <        06-21-1996 Sven B. Schreiber sbs@psbs.franken.de/n>
STRING <                 This is Public Domain Software/n>
STRING <________________________________________________________________/n>
STRING </n/0>
;
sUsage:			STRING	</nUsage:  NW_Info /(Server/) >
			STRING	<[/(User/) [/(Password/)]]/n/0>
;
sMainCaption:		STRING	<Win32 NetWare API Demo/0>
sNoErrorMessage:	STRING	<No error message available./n/0>
sAttachInfo:		STRING	</n/)/)/) Attaching to /=/0/=/n/0>
sLoginInfo:		STRING	</)/)/) Logging into /=/0/= /0as /=/0/=/n/0>
sAttachFailure:		STRING	</n/:/:/: SERVER NOT FOUND /:/:/:/n/0>
sLoginFailure:		STRING	</n/:/:/: LOGIN FAILURE /:/:/:/n/0>
sUnknown:		STRING	<???/0>
sNewLine:		STRING	</n/0>
;
;------------------------------------------------------------------------------
;
sServerName:		STRING	</nServer Name:      /0/0>
sFileServiceVersion:	STRING	</nServer Version:   /0/0>
sMaxConnections:	STRING	</nMax Connections:  /0/0>
sPeakConnections:	STRING	</nMax Ever Used:    /0/0>
sUsedConnections:	STRING	</nCurrently Used:   /0/0>
sConnectionNumber:	STRING	</nStation Number:   /0/n/0>
sObjectName:		STRING	</nObject Name:      /0/0>
sObjectType:		STRING	</nObject Type:      /0/0>
sObjectId:		STRING	</nObject ID:        /0/n/0>
sLoginTime:		STRING	</nLogin Time:       /0/0 - /0/0>
sServerTime:		STRING	</nServer Time:      /0/0 - /0/0>
sUtcTime:		STRING	</nUTC Time:         /0/0 - /0/0>
sLoginKey:		STRING	</nLogin Key:        /0/0>
sServerVolumes:		STRING	</n/nServer Disk Volumes:/n>
			STRING	    <--------------------/n/0>
sVolumeName:		STRING	</n -/) /0/0>
;
;==============================================================================
;
EndIData
;
;==============================================================================
;
;	UNINITIALIZED DATA
;
;------------------------------------------------------------------------------
;
OsVersionInfo		OSVERSIONINFO {}
StartupInfo		STARTUPINFO {}
VersionInfo		VERSION_INFO {}
LoginTime		NWDATE_TIME {}
ServerTime		NWDATE_TIME {}
UtcTime			NWDATE_TIME {}
LoginKey		NWLOGIN_KEY {}
sLoadFile		CHAR MAX_PATH dup (?)
sHexNumber16		CHAR MAX_HEX_16 dup (?)
sHexNumber32		CHAR MAX_HEX_32 dup (?)
sHexNumber64		CHAR MAX_HEX_64 dup (?)
sVersionNumber		CHAR VERSION_NUMBER_LENGTH dup (?)
sLongDate		CHAR LONG_DATE_LENGTH dup (?)
sTime			CHAR TIME_LENGTH dup (?)
sServer			CHAR NW_MAX_SERVER_NAME_LEN dup (?)
sLoginName		CHAR NW_MAX_OBJECT_NAME_LEN dup (?)
sLoginPassword		CHAR NW_MAX_PASSWORD_LEN dup (?)
sVolumeNameBuffer	CHAR NW_MAX_VOLUME_NAME_LEN dup (?)
sObjectNameBuffer	CHAR NW_MAX_OBJECT_NAME_LEN dup (?)
;
;------------------------------------------------------------------------------
;
hStdInput		HANDLE	?
hStdOutput		HANDLE	?
hStdError		HANDLE	?
dWriteFileCount		DWORD	?	
pMessageBuffer		POINTER	?
;
dConnectionHandle	DWORD	?
wConnectionNumber	WORD	?
;
wObjectType		WORD	?
dObjectId		DWORD	?
dUtcTime		DWORD	?
;
;==============================================================================
;
EndUData
;
;==============================================================================
;
EndImage

