//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : OWNERR.CPP
//
// Description:
//		Implemetation of own error-handler
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>

#include "defines.h"
#include "ownerr.h"

unsigned int FKT_errorcnt=0;

char *alloc_msgmem(void)
{
	char *msgbuff;

	if ((msgbuff=new char[ERR_MSG_LEN])==NULL)
		fatal("out of memory");
	return(msgbuff);
}

void dealloc_msgmem(char *msgbuff)
{
	delete msgbuff;
}

void warning(char *msg,unsigned int line)
{
	if (line==0)
		fprintf(stderr,"\nWARNING:%s\n\n",msg);
	else
		fprintf(stderr,"\nWARNING:line %u:%s\n\n",line,msg);
	if (V_STOP_ON_WARNING=='Y')
	{
		fprintf(stderr,"Terminating program...\n");
		exit(1);
	}
}

void error(char *msg,unsigned int line)
{
	if (line==0)
		fprintf(stderr,"\nERROR:%s\n\n",msg);
	else
		fprintf(stderr,"\nERROR:line %u:%s\n\n",line,msg);
	if (V_STOP_ON_ERROR=='Y')
	{
		fprintf(stderr,"Terminating program...\n");
		exit(1);
	}
}

void fatal(char *msg,unsigned int line)
{
	if (line==0)
		fprintf(stderr,"\nFATAL:%s\n",msg);
	else
		fprintf(stderr,"\nFATAL:line %u:%s\n",line,msg);
	fprintf(stderr,"Terminating program...\n");
	exit(1);
}

void FKT_error(char *msg,unsigned int line)
{
	FKT_errorcnt++;
	error(msg,line);
}
