// ------ Sheet.cpp

#include "stdafx.h"
#include "PropSheet.h"
#include "Sheet.h"

IMPLEMENT_DYNAMIC(CSheet, CPropertySheet)

CSheet::CSheet() : CPropertySheet("Test Property Sheets", 0, 0)
{
	m_psh.dwFlags |= PSH_NOAPPLYNOW; 
	m_psh.dwFlags &= ~PSH_HASHELP;
	AddPage(&m_CPage);
    m_bExitEnabled = TRUE;
}
CSheet::~CSheet()
{
}
void CSheet::Initialize()
{
    CWnd* pWnd = GetDlgItem(IDOK);
    if (pWnd != 0)  {
        pWnd->ShowWindow(SW_HIDE);
        pWnd->EnableWindow(FALSE);
    }
    pWnd = GetDlgItem(IDCANCEL);
    if (pWnd != 0)
        pWnd->SetWindowText("Exit");
}
BEGIN_MESSAGE_MAP(CSheet, CPropertySheet)
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()

void CSheet::OnSysCommand(UINT nID, LPARAM lParam) 
{
    if (nID != SC_CLOSE || m_bExitEnabled == TRUE)
        CPropertySheet::OnSysCommand(nID, lParam);
}
void CSheet::EnableExit()
{
    CMenu* pCMenu = GetSystemMenu(FALSE);
    ASSERT(pCMenu != 0);
    pCMenu->EnableMenuItem(SC_CLOSE, MF_ENABLED);
    CWnd* pWnd = GetDlgItem(IDCANCEL);
    if (pWnd != 0)
        pWnd->EnableWindow(TRUE);
    m_bExitEnabled = TRUE;
}
void CSheet::DisableExit()
{
    CMenu* pCMenu = GetSystemMenu(FALSE);
    ASSERT(pCMenu != 0);
    pCMenu->EnableMenuItem(SC_CLOSE, MF_GRAYED);
    CWnd* pWnd = GetDlgItem(IDCANCEL);
    if (pWnd != 0)
        pWnd->EnableWindow(FALSE);
    m_bExitEnabled = FALSE;
}
