//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : SIMPLVAR.H
//
// Description:
//		Definition of class SimpleVariable derived from ListElement.
//		It is specially designed to store variables with double values.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __SIMPLEVARIABLE

#include "ListElem.h"

class SimpleVariable : public ListElement
{
	VALUETYPE Value;
	VALUETYPE InitialValue;

public:
	// constructor
	SimpleVariable(char *key);
	SimpleVariable(char *key,VALUETYPE Value);

	// destructor
	~SimpleVariable(void);

	// value operations
	VALUETYPE GetValue(void);
	void SetValue(VALUETYPE value);
	void SetInitialValue(void);
};

#define __SIMPLEVARIABLE
#endif

