//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : SINGLIST.CPP
//
// Description:
//		Implementation of class SinglyList.
//		It uses instances of class ListElement as elements.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "SingList.h"

#define FALSE 0
#define TRUE  1

SinglyList::SinglyList(void)
{
	ElementList=NULL;
}

SinglyList::~SinglyList(void)
{
	CleanUp();
}

void SinglyList::Insert(ListElement *newelement)
{
	LElement *help;

	if ((help=new LElement)==NULL)
	{
		fprintf(stderr,"SINGLYLIST: out of memory!! Aborting program!!\n");
		exit(1);
	}
	help->Element=newelement;
	help->Next=ElementList;
	ElementList=help;
}

ListElement *SinglyList::Search(char *key,char type)
{
	LElement *help;
	char found=FALSE;

	help=ElementList;
	while ((help!=NULL) && (found==FALSE))
	{
		if ((strcmp(help->Element->GetKey(),key)==0) &&
		    (help->Element->GetType()==type))
			found=TRUE;
	   else
			help=help->Next;
	}
	return(found==TRUE ? help->Element : NULL);
}

void SinglyList::CleanUp(void)
{
	RemoveAll(ElementList);
	ElementList=NULL;
}

void SinglyList::SetInitialValue(void)
{
	LElement *help;

	help=ElementList;
	while (help!=NULL)
	{
		help->Element->SetInitialValue();
		help=help->Next;
	}
}

// private methods
void SinglyList::RemoveAll(LElement *list)
{
	if (list!=NULL)
	{
		list=list->Next;
		delete list;
	}
}
