//////////////////////////////////////////////////////////////////////////////
//
// DIPLOMARBEIT : WAVE-GL 	Inst. f. techn. Mathematik / TU-WIEN
//
// Author : Michael Mueller-Wernhart
//
//////////////////////////////////////////////////////////////////////////////
//
// MODULE : SINGLIST.H
//
// Description:
//		Definition of class SinglyList.
//		It uses instances of class ListElement as elements.
//
//
//	Version 1.0
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __SINGLYLIST

#include "ListElem.h"

typedef struct LElement_struct
{
	ListElement *Element;
	LElement_struct *Next;
} LElement;

class SinglyList
{
	LElement *ElementList;

public:
	// constructor
	SinglyList(void);

	// destructor
	~SinglyList(void);

	// list operations
	// insert new element on head of list
	void Insert(ListElement *newelement);
	// search element with specific key
	ListElement *Search(char *key,char type);

	// Remove complete list
	void CleanUp(void);

	// Reset all Elements to their predefined values
	void SetInitialValue(void);

private:
	void RemoveAll(LElement *list);
};

#define __SINGLYLIST
#endif

